/* libnotify.c generated by valac 0.34.9, the Vala compiler
 * generated from libnotify.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Displays a notification via libnotify*/

#include <glib.h>
#include <glib-object.h>
#include "geary-static.h"
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <canberra.h>
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_LIBNOTIFY (libnotify_get_type ())
#define LIBNOTIFY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LIBNOTIFY, Libnotify))
#define LIBNOTIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LIBNOTIFY, LibnotifyClass))
#define IS_LIBNOTIFY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LIBNOTIFY))
#define IS_LIBNOTIFY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LIBNOTIFY))
#define LIBNOTIFY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LIBNOTIFY, LibnotifyClass))

typedef struct _Libnotify Libnotify;
typedef struct _LibnotifyClass LibnotifyClass;
typedef struct _LibnotifyPrivate LibnotifyPrivate;

#define TYPE_NEW_MESSAGES_MONITOR (new_messages_monitor_get_type ())
#define NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitor))
#define NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))
#define IS_NEW_MESSAGES_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_MESSAGES_MONITOR))
#define IS_NEW_MESSAGES_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_MESSAGES_MONITOR))
#define NEW_MESSAGES_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_MESSAGES_MONITOR, NewMessagesMonitorClass))

typedef struct _NewMessagesMonitor NewMessagesMonitor;
typedef struct _NewMessagesMonitorClass NewMessagesMonitorClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _ca_context_destroy0(var) ((var == NULL) ? NULL : (var = (ca_context_destroy (var), NULL)))

#define TYPE_GEARY_APPLICATION (geary_application_get_type ())
#define GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GEARY_APPLICATION, GearyApplication))
#define GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GEARY_APPLICATION, GearyApplicationClass))
#define IS_GEARY_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GEARY_APPLICATION))
#define IS_GEARY_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GEARY_APPLICATION))
#define GEARY_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GEARY_APPLICATION, GearyApplicationClass))

typedef struct _GearyApplication GearyApplication;
typedef struct _GearyApplicationClass GearyApplicationClass;

#define TYPE_CONFIGURATION (configuration_get_type ())
#define CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONFIGURATION, Configuration))
#define CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONFIGURATION, ConfigurationClass))
#define IS_CONFIGURATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONFIGURATION))
#define IS_CONFIGURATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONFIGURATION))
#define CONFIGURATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONFIGURATION, ConfigurationClass))

typedef struct _Configuration Configuration;
typedef struct _ConfigurationClass ConfigurationClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define GRAVATAR_TYPE_DEFAULT (gravatar_default_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _LibnotifyNotifyOneMessageAsyncData LibnotifyNotifyOneMessageAsyncData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Libnotify {
	GearyBaseObject parent_instance;
	LibnotifyPrivate * priv;
};

struct _LibnotifyClass {
	GearyBaseObjectClass parent_class;
};

struct _LibnotifyPrivate {
	NewMessagesMonitor* monitor;
	NotifyNotification* current_notification;
	NotifyNotification* error_notification;
	GearyFolder* folder;
	GearyEmail* email;
	GList* caps;
};

typedef enum  {
	GRAVATAR_DEFAULT_NOT_FOUND,
	GRAVATAR_DEFAULT_MYSTERY_MAN,
	GRAVATAR_DEFAULT_IDENTICON,
	GRAVATAR_DEFAULT_MONSTER_ID,
	GRAVATAR_DEFAULT_WAVATAR,
	GRAVATAR_DEFAULT_RETRO
} GravatarDefault;

struct _LibnotifyNotifyOneMessageAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Libnotify* self;
	GearyFolder* folder;
	GearyEmail* email;
	GCancellable* cancellable;
	GearyEmail* _tmp0_;
	GearyEmailField _tmp1_;
	GearyEmailField _tmp2_;
	gboolean _tmp3_;
	GearyFolder* _tmp4_;
	GearyFolder* _tmp5_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
	gboolean _tmp8_;
	GearyApplication* _tmp9_;
	GearyApplication* _tmp10_;
	Configuration* _tmp11_;
	Configuration* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	NewMessagesMonitor* _tmp15_;
	GearyFolder* _tmp16_;
	gboolean _tmp17_;
	GearyRFC822MailboxAddress* primary;
	GearyEmail* _tmp18_;
	GearyRFC822MailboxAddress* _tmp19_;
	GearyRFC822MailboxAddress* _tmp20_;
	GearyFolder* _tmp21_;
	gchar* body;
	gint count;
	NewMessagesMonitor* _tmp22_;
	GearyFolder* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GearyEmail* _tmp26_;
	gchar* _tmp27_;
	gint _tmp28_;
	const gchar* _tmp29_;
	GearyEmail* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	gint _tmp33_;
	GearyFolder* _tmp34_;
	GearyAccount* _tmp35_;
	GearyAccount* _tmp36_;
	GearyAccountInformation* _tmp37_;
	GearyAccountInformation* _tmp38_;
	const gchar* _tmp39_;
	const gchar* _tmp40_;
	gchar* _tmp41_;
	GdkPixbuf* avatar;
	GInputStream* ins;
	GFile* file;
	GearyRFC822MailboxAddress* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GFile* _tmp45_;
	GFile* _tmp46_;
	GFileInputStream* _tmp47_;
	GFile* _tmp48_;
	GCancellable* _tmp49_;
	GFileInputStream* _tmp50_;
	GFileInputStream* _tmp51_;
	GdkPixbuf* _tmp52_;
	GInputStream* _tmp53_;
	GCancellable* _tmp54_;
	GdkPixbuf* _tmp55_;
	GdkPixbuf* _tmp56_;
	GError* err;
	GError* _tmp57_;
	const gchar* _tmp58_;
	GInputStream* _tmp59_;
	GInputStream* _tmp60_;
	GCancellable* _tmp61_;
	GError* close_err;
	GearyRFC822MailboxAddress* _tmp62_;
	gchar* _tmp63_;
	gchar* _tmp64_;
	const gchar* _tmp65_;
	GdkPixbuf* _tmp66_;
	GError * _inner_error_;
};


static gpointer libnotify_parent_class = NULL;
static ca_context* libnotify_sound_context;
static ca_context* libnotify_sound_context = NULL;

GType libnotify_get_type (void) G_GNUC_CONST;
GType new_messages_monitor_get_type (void) G_GNUC_CONST;
#define LIBNOTIFY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_LIBNOTIFY, LibnotifyPrivate))
enum  {
	LIBNOTIFY_DUMMY_PROPERTY
};
static void libnotify_on_new_messages_arrived (Libnotify* self, GearyFolder* folder, gint total, gint added);
static void _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived (NewMessagesMonitor* _sender, GearyFolder* folder, gint total, gint added, gpointer self);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
#define LIBNOTIFY_REQUIRED_FIELDS (GEARY_EMAIL_FIELD_ORIGINATORS | GEARY_EMAIL_FIELD_SUBJECT)
Libnotify* libnotify_new (NewMessagesMonitor* monitor);
Libnotify* libnotify_construct (GType object_type, NewMessagesMonitor* monitor);
void new_messages_monitor_add_required_fields (NewMessagesMonitor* self, GearyEmailField fields);
#define GEARY_APPLICATION_PRGNAME "geary"
static void libnotify_init_sound (void);
GearyFolder* new_messages_monitor_get_last_new_message_folder (NewMessagesMonitor* self);
GearyEmail* new_messages_monitor_get_last_new_message (NewMessagesMonitor* self);
static void libnotify_notify_one_message_async (Libnotify* self, GearyFolder* folder, GearyEmail* email, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void libnotify_notify_one_message_finish (Libnotify* self, GAsyncResult* _res_, GError** error);
static void libnotify_notify_new_mail (Libnotify* self, GearyFolder* folder, gint added);
static void libnotify_on_default_action (Libnotify* self, NotifyNotification* notification, const gchar* action);
GType geary_application_get_type (void) G_GNUC_CONST;
GearyApplication* geary_application_get_instance (void);
gpointer configuration_ref (gpointer instance);
void configuration_unref (gpointer instance);
GParamSpec* param_spec_configuration (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_configuration (GValue* value, gpointer v_object);
void value_take_configuration (GValue* value, gpointer v_object);
gpointer value_get_configuration (const GValue* value);
GType configuration_get_type (void) G_GNUC_CONST;
Configuration* geary_application_get_config (GearyApplication* self);
gboolean configuration_get_show_notifications (Configuration* self);
gboolean new_messages_monitor_should_notify_new_messages (NewMessagesMonitor* self, GearyFolder* folder);
gint new_messages_monitor_get_new_message_count (NewMessagesMonitor* self, GearyFolder* folder);
static void libnotify_issue_current_notification (Libnotify* self, const gchar* summary, const gchar* body, GdkPixbuf* icon);
static void libnotify_notify_one_message_async_data_free (gpointer _data);
static gboolean libnotify_notify_one_message_async_co (LibnotifyNotifyOneMessageAsyncData* _data_);
gchar* email_util_strip_subject_prefixes (GearyEmail* email);
GType gravatar_default_get_type (void) G_GNUC_CONST;
gchar* gravatar_get_image_uri (GearyRFC822MailboxAddress* addr, GravatarDefault def, gint size);
#define GRAVATAR_DEFAULT_SIZE 80
static void libnotify_notify_one_message_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static NotifyNotification* libnotify_issue_notification (Libnotify* self, const gchar* category, const gchar* summary, const gchar* body, GdkPixbuf* icon, const gchar* sound);
static void _libnotify_on_default_action_notify_action_callback (NotifyNotification* notification, const gchar* action, gpointer self);
void libnotify_play_sound (const gchar* sound);
gboolean configuration_get_play_sounds (Configuration* self);
void libnotify_set_error_notification (Libnotify* self, const gchar* summary, const gchar* body);
void libnotify_clear_error_notification (Libnotify* self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void libnotify_finalize (GObject* obj);


static void _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived (NewMessagesMonitor* _sender, GearyFolder* folder, gint total, gint added, gpointer self) {
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_on_new_messages_arrived ((Libnotify*) self, folder, total, added);
#line 253 "libnotify.c"
}


static void _g_free0_ (gpointer var) {
#line 19 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	var = (g_free (var), NULL);
#line 260 "libnotify.c"
}


static void _g_list_free__g_free0_ (GList* self) {
#line 19 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
#line 19 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_list_free (self);
#line 269 "libnotify.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 24 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return self ? g_object_ref (self) : NULL;
#line 276 "libnotify.c"
}


Libnotify* libnotify_construct (GType object_type, NewMessagesMonitor* monitor) {
	Libnotify * self = NULL;
	NewMessagesMonitor* _tmp0_ = NULL;
	NewMessagesMonitor* _tmp1_ = NULL;
	NewMessagesMonitor* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	GList* _tmp5_ = NULL;
	NewMessagesMonitor* _tmp6_ = NULL;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail (IS_NEW_MESSAGES_MONITOR (monitor), NULL);
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self = (Libnotify*) geary_base_object_construct (object_type);
#line 24 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = monitor;
#line 24 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 24 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->monitor);
#line 24 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->monitor = _tmp1_;
#line 26 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = monitor;
#line 26 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	new_messages_monitor_add_required_fields (_tmp2_, LIBNOTIFY_REQUIRED_FIELDS);
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = notify_is_initted ();
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (!_tmp3_) {
#line 308 "libnotify.c"
		gboolean _tmp4_ = FALSE;
#line 29 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp4_ = notify_init (GEARY_APPLICATION_PRGNAME);
#line 29 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (!_tmp4_) {
#line 30 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_message ("libnotify.vala:30: Failed to initialize libnotify.");
#line 316 "libnotify.c"
		}
	}
#line 33 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_init_sound ();
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = notify_get_server_caps ();
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	__g_list_free__g_free0_0 (self->priv->caps);
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->caps = _tmp5_;
#line 38 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = monitor;
#line 38 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_signal_connect_object (_tmp6_, "new-messages-arrived", (GCallback) _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived, self, 0);
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return self;
#line 333 "libnotify.c"
}


Libnotify* libnotify_new (NewMessagesMonitor* monitor) {
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return libnotify_construct (TYPE_LIBNOTIFY, monitor);
#line 340 "libnotify.c"
}


static void libnotify_init_sound (void) {
	ca_context* _tmp0_ = NULL;
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = libnotify_sound_context;
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_ == NULL) {
#line 350 "libnotify.c"
		ca_context* _tmp1_ = NULL;
#line 47 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		ca_context_create (&_tmp1_);
#line 47 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_ca_context_destroy0 (libnotify_sound_context);
#line 47 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		libnotify_sound_context = _tmp1_;
#line 358 "libnotify.c"
	}
}


static void libnotify_on_new_messages_arrived (Libnotify* self, GearyFolder* folder, gint total, gint added) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gint _tmp2_ = 0;
#line 50 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 50 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = added;
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp2_ == 1) {
#line 375 "libnotify.c"
		NewMessagesMonitor* _tmp3_ = NULL;
		GearyFolder* _tmp4_ = NULL;
		GearyFolder* _tmp5_ = NULL;
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp3_ = self->priv->monitor;
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp4_ = new_messages_monitor_get_last_new_message_folder (_tmp3_);
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp5_ = _tmp4_;
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp1_ = _tmp5_ != NULL;
#line 387 "libnotify.c"
	} else {
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp1_ = FALSE;
#line 391 "libnotify.c"
	}
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp1_) {
#line 395 "libnotify.c"
		NewMessagesMonitor* _tmp6_ = NULL;
		GearyEmail* _tmp7_ = NULL;
		GearyEmail* _tmp8_ = NULL;
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp6_ = self->priv->monitor;
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp7_ = new_messages_monitor_get_last_new_message (_tmp6_);
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp8_ = _tmp7_;
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp0_ = _tmp8_ != NULL;
#line 407 "libnotify.c"
	} else {
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp0_ = FALSE;
#line 411 "libnotify.c"
	}
#line 51 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_) {
#line 415 "libnotify.c"
		NewMessagesMonitor* _tmp9_ = NULL;
		GearyFolder* _tmp10_ = NULL;
		GearyFolder* _tmp11_ = NULL;
		NewMessagesMonitor* _tmp12_ = NULL;
		GearyEmail* _tmp13_ = NULL;
		GearyEmail* _tmp14_ = NULL;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp9_ = self->priv->monitor;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp10_ = new_messages_monitor_get_last_new_message_folder (_tmp9_);
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp11_ = _tmp10_;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp12_ = self->priv->monitor;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp13_ = new_messages_monitor_get_last_new_message (_tmp12_);
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp14_ = _tmp13_;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		libnotify_notify_one_message_async (self, _tmp11_, _tmp14_, NULL, NULL, NULL);
#line 436 "libnotify.c"
	} else {
		gint _tmp15_ = 0;
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp15_ = added;
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (_tmp15_ > 0) {
#line 443 "libnotify.c"
			GearyFolder* _tmp16_ = NULL;
			gint _tmp17_ = 0;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp16_ = folder;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp17_ = added;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			libnotify_notify_new_mail (self, _tmp16_, _tmp17_);
#line 452 "libnotify.c"
		}
	}
}


static void libnotify_on_default_action (Libnotify* self, NotifyNotification* notification, const gchar* action) {
	GearyFolder* _tmp0_ = NULL;
	GearyEmail* _tmp1_ = NULL;
	GearyApplication* _tmp2_ = NULL;
	GearyApplication* _tmp3_ = NULL;
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (NOTIFY_IS_NOTIFICATION (notification));
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (action != NULL);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->folder;
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = self->priv->email;
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_signal_emit_by_name (self, "invoked", _tmp0_, _tmp1_);
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = geary_application_get_instance ();
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = _tmp2_;
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_application_activate (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, g_application_get_type (), GApplication));
#line 481 "libnotify.c"
}


static void libnotify_notify_new_mail (Libnotify* self, GearyFolder* folder, gint added) {
	gboolean _tmp0_ = FALSE;
	GearyApplication* _tmp1_ = NULL;
	GearyApplication* _tmp2_ = NULL;
	Configuration* _tmp3_ = NULL;
	Configuration* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* body = NULL;
	gint _tmp10_ = 0;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gchar* _tmp13_ = NULL;
	gint total = 0;
	NewMessagesMonitor* _tmp14_ = NULL;
	GearyFolder* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	GearyFolder* _tmp24_ = NULL;
	GearyAccount* _tmp25_ = NULL;
	GearyAccount* _tmp26_ = NULL;
	GearyAccountInformation* _tmp27_ = NULL;
	GearyAccountInformation* _tmp28_ = NULL;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	const gchar* _tmp31_ = NULL;
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (GEARY_IS_FOLDER (folder));
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->folder);
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->folder = NULL;
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->email);
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->email = NULL;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = geary_application_get_instance ();
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = _tmp1_;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = geary_application_get_config (_tmp2_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp4_ = _tmp3_;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = configuration_get_show_notifications (_tmp4_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = _tmp5_;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (!_tmp6_) {
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp0_ = TRUE;
#line 540 "libnotify.c"
	} else {
		NewMessagesMonitor* _tmp7_ = NULL;
		GearyFolder* _tmp8_ = NULL;
		gboolean _tmp9_ = FALSE;
#line 71 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp7_ = self->priv->monitor;
#line 71 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp8_ = folder;
#line 71 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp9_ = new_messages_monitor_should_notify_new_messages (_tmp7_, _tmp8_);
#line 71 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp0_ = !_tmp9_;
#line 553 "libnotify.c"
	}
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_) {
#line 72 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return;
#line 559 "libnotify.c"
	}
#line 74 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp10_ = added;
#line 74 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp11_ = ngettext ("%d new message", "%d new messages", (gulong) _tmp10_);
#line 74 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp12_ = added;
#line 74 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp13_ = g_strdup_printf (_tmp11_, _tmp12_);
#line 74 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	body = _tmp13_;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp14_ = self->priv->monitor;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp15_ = folder;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp16_ = new_messages_monitor_get_new_message_count (_tmp14_, _tmp15_);
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	total = _tmp16_;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp17_ = total;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp18_ = added;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp17_ > _tmp18_) {
#line 585 "libnotify.c"
		gint _tmp19_ = 0;
		const gchar* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		gchar* _tmp23_ = NULL;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp19_ = total;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp20_ = ngettext ("%s, %d new message total", "%s, %d new messages total", (gulong) _tmp19_);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp21_ = body;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp22_ = total;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp23_ = g_strdup_printf (_tmp20_, _tmp21_, _tmp22_);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_free0 (body);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		body = _tmp23_;
#line 605 "libnotify.c"
	}
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp24_ = folder;
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp25_ = geary_folder_get_account (_tmp24_);
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp26_ = _tmp25_;
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp27_ = geary_account_get_information (_tmp26_);
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp28_ = _tmp27_;
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp29_ = geary_account_information_get_email (_tmp28_);
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp30_ = _tmp29_;
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp31_ = body;
#line 81 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_issue_current_notification (self, _tmp30_, _tmp31_, NULL);
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_free0 (body);
#line 627 "libnotify.c"
}


static void libnotify_notify_one_message_async_data_free (gpointer _data) {
	LibnotifyNotifyOneMessageAsyncData* _data_;
	_data_ = _data;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->folder);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->email);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->cancellable);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_slice_free (LibnotifyNotifyOneMessageAsyncData, _data_);
#line 644 "libnotify.c"
}


static void libnotify_notify_one_message_async (Libnotify* self, GearyFolder* folder, GearyEmail* email, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	LibnotifyNotifyOneMessageAsyncData* _data_;
	Libnotify* _tmp0_ = NULL;
	GearyFolder* _tmp1_ = NULL;
	GearyFolder* _tmp2_ = NULL;
	GearyEmail* _tmp3_ = NULL;
	GearyEmail* _tmp4_ = NULL;
	GCancellable* _tmp5_ = NULL;
	GCancellable* _tmp6_ = NULL;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_ = g_slice_new0 (LibnotifyNotifyOneMessageAsyncData);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, libnotify_notify_one_message_async);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, libnotify_notify_one_message_async_data_free);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->self = _tmp0_;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = folder;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->folder);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->folder = _tmp2_;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = email;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->email);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->email = _tmp4_;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = cancellable;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->cancellable);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->cancellable = _tmp6_;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_notify_one_message_async_co (_data_);
#line 693 "libnotify.c"
}


static void libnotify_notify_one_message_finish (Libnotify* self, GAsyncResult* _res_, GError** error) {
	LibnotifyNotifyOneMessageAsyncData* _data_;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (g_simple_async_result_propagate_error (G_SIMPLE_ASYNC_RESULT (_res_), error)) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return;
#line 703 "libnotify.c"
	}
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
#line 707 "libnotify.c"
}


static void libnotify_notify_one_message_async_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	LibnotifyNotifyOneMessageAsyncData* _data_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_ = _user_data_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_source_object_ = source_object;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_res_ = _res_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_notify_one_message_async_co (_data_);
#line 721 "libnotify.c"
}


static gboolean libnotify_notify_one_message_async_co (LibnotifyNotifyOneMessageAsyncData* _data_) {
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	switch (_data_->_state_) {
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		case 0:
#line 730 "libnotify.c"
		goto _state_0;
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		case 1:
#line 734 "libnotify.c"
		goto _state_1;
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		case 2:
#line 738 "libnotify.c"
		goto _state_2;
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		case 3:
#line 742 "libnotify.c"
		goto _state_3;
		default:
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_assert_not_reached ();
#line 747 "libnotify.c"
	}
	_state_0:
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp0_ = NULL;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp0_ = _data_->email;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp1_ = 0;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp1_ = geary_email_get_fields (_data_->_tmp0_);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp2_ = 0;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp3_ = FALSE;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp3_ = geary_email_field_fulfills (_data_->_tmp2_, LIBNOTIFY_REQUIRED_FIELDS);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_vala_assert (_data_->_tmp3_, "email.fields.fulfills(REQUIRED_FIELDS)");
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp4_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp4_ = _data_->folder;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp5_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp5_ = _g_object_ref0 (_data_->_tmp4_);
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self->priv->folder);
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->self->priv->folder = _data_->_tmp5_;
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp6_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp6_ = _data_->email;
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp7_ = NULL;
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp7_ = _g_object_ref0 (_data_->_tmp6_);
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->self->priv->email);
#line 90 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->self->priv->email = _data_->_tmp7_;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp9_ = NULL;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp9_ = geary_application_get_instance ();
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp10_ = NULL;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp11_ = NULL;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp11_ = geary_application_get_config (_data_->_tmp10_);
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp12_ = NULL;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp13_ = FALSE;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp13_ = configuration_get_show_notifications (_data_->_tmp12_);
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp14_ = FALSE;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (!_data_->_tmp14_) {
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp8_ = TRUE;
#line 820 "libnotify.c"
	} else {
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp15_ = NULL;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp15_ = _data_->self->priv->monitor;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp16_ = NULL;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp16_ = _data_->folder;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp17_ = FALSE;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp17_ = new_messages_monitor_should_notify_new_messages (_data_->_tmp15_, _data_->_tmp16_);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp8_ = !_data_->_tmp17_;
#line 836 "libnotify.c"
	}
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_data_->_tmp8_) {
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (_data_->_state_ == 0) {
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 844 "libnotify.c"
		} else {
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 848 "libnotify.c"
		}
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return FALSE;
#line 854 "libnotify.c"
	}
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp18_ = NULL;
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp18_ = _data_->email;
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp19_ = NULL;
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp19_ = geary_email_get_primary_originator (_data_->_tmp18_);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->primary = _data_->_tmp19_;
#line 98 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp20_ = NULL;
#line 98 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp20_ = _data_->primary;
#line 98 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_data_->_tmp20_ == NULL) {
#line 99 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp21_ = NULL;
#line 99 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp21_ = _data_->folder;
#line 99 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		libnotify_notify_new_mail (_data_->self, _data_->_tmp21_, 1);
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->primary);
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (_data_->_state_ == 0) {
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 884 "libnotify.c"
		} else {
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 888 "libnotify.c"
		}
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return FALSE;
#line 894 "libnotify.c"
	}
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp22_ = NULL;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp22_ = _data_->self->priv->monitor;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp23_ = NULL;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp23_ = _data_->folder;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp24_ = 0;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp24_ = new_messages_monitor_get_new_message_count (_data_->_tmp22_, _data_->_tmp23_);
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->count = _data_->_tmp24_;
#line 106 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp25_ = 0;
#line 106 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp25_ = _data_->count;
#line 106 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_data_->_tmp25_ <= 1) {
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp26_ = NULL;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp26_ = _data_->email;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp27_ = NULL;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp27_ = email_util_strip_subject_prefixes (_data_->_tmp26_);
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->body = _data_->_tmp27_;
#line 928 "libnotify.c"
	} else {
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp28_ = 0;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp28_ = _data_->count;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp29_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp29_ = ngettext ("%s\n(%d other new message for %s)", "%s\n(%d other new messages for %s)", (gulong) (_data_->_tmp28_ - 1));
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp30_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp30_ = _data_->email;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp31_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp31_ = email_util_strip_subject_prefixes (_data_->_tmp30_);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp32_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp32_ = _data_->_tmp31_;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp33_ = 0;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp33_ = _data_->count;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp34_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp34_ = _data_->folder;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp35_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp35_ = geary_folder_get_account (_data_->_tmp34_);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp36_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp36_ = _data_->_tmp35_;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp37_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp37_ = geary_account_get_information (_data_->_tmp36_);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp38_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp38_ = _data_->_tmp37_;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp39_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp39_ = geary_account_information_get_email (_data_->_tmp38_);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp40_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp40_ = _data_->_tmp39_;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp41_ = NULL;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp41_ = g_strdup_printf (_data_->_tmp29_, _data_->_tmp32_, _data_->_tmp33_ - 1, _data_->_tmp40_);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->body = _data_->_tmp41_;
#line 109 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_free0 (_data_->_tmp32_);
#line 992 "libnotify.c"
	}
#line 114 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->avatar = NULL;
#line 115 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->ins = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp42_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp42_ = _data_->primary;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp43_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp43_ = gravatar_get_image_uri (_data_->_tmp42_, GRAVATAR_DEFAULT_MYSTERY_MAN, GRAVATAR_DEFAULT_SIZE);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp44_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp45_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp45_ = g_file_new_for_uri (_data_->_tmp44_);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp46_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_free0 (_data_->_tmp44_);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->file = _data_->_tmp46_;
#line 1022 "libnotify.c"
	{
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp48_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp48_ = _data_->file;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp49_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp49_ = _data_->cancellable;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_state_ = 1;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_file_read_async (_data_->_tmp48_, G_PRIORITY_DEFAULT, _data_->_tmp49_, libnotify_notify_one_message_async_ready, _data_);
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return FALSE;
#line 1038 "libnotify.c"
		_state_1:
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp50_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp50_ = g_file_read_finish (_data_->_tmp48_, _data_->_res_, &_data_->_inner_error_);
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp47_ = _data_->_tmp50_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 1048 "libnotify.c"
			goto __catch172_g_error;
		}
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp51_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp51_ = _data_->_tmp47_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp47_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->ins = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp51_, g_input_stream_get_type (), GInputStream);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp53_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp53_ = _data_->ins;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp54_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp54_ = _data_->cancellable;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_state_ = 2;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		gdk_pixbuf_new_from_stream_async (_data_->_tmp53_, _data_->_tmp54_, libnotify_notify_one_message_async_ready, _data_);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return FALSE;
#line 1075 "libnotify.c"
		_state_2:
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp55_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp55_ = gdk_pixbuf_new_from_stream_finish (_data_->_res_, &_data_->_inner_error_);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp52_ = _data_->_tmp55_;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->_tmp47_);
#line 1087 "libnotify.c"
			goto __catch172_g_error;
		}
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp56_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp56_ = _data_->_tmp52_;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp52_ = NULL;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->avatar);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->avatar = _data_->_tmp56_;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->_tmp52_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->_tmp47_);
#line 1104 "libnotify.c"
	}
	goto __finally172;
	__catch172_g_error:
	{
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->err = _data_->_inner_error_;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_inner_error_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp57_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp57_ = _data_->err;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp58_ = NULL;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->_tmp58_ = _data_->_tmp57_->message;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_debug ("libnotify.vala:121: Failed to get avatar for notification: %s", _data_->_tmp58_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_error_free0 (_data_->err);
#line 1125 "libnotify.c"
	}
	__finally172:
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_error_free (_data_->_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->file);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->avatar);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_free0 (_data_->body);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->primary);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (_data_->_state_ == 0) {
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1148 "libnotify.c"
		} else {
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_complete (_data_->_async_result);
#line 1152 "libnotify.c"
		}
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_object_unref (_data_->_async_result);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return FALSE;
#line 1158 "libnotify.c"
	}
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp59_ = NULL;
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp59_ = _data_->ins;
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_data_->_tmp59_ != NULL) {
#line 1166 "libnotify.c"
		{
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_tmp60_ = NULL;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_tmp60_ = _data_->ins;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_tmp61_ = NULL;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_tmp61_ = _data_->cancellable;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_state_ = 3;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_input_stream_close_async (_data_->_tmp60_, G_PRIORITY_DEFAULT, _data_->_tmp61_, libnotify_notify_one_message_async_ready, _data_);
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			return FALSE;
#line 1182 "libnotify.c"
			_state_3:
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_input_stream_close_finish (_data_->_tmp60_, _data_->_res_, &_data_->_inner_error_);
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 1188 "libnotify.c"
				goto __catch173_g_error;
			}
		}
		goto __finally173;
		__catch173_g_error:
		{
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->close_err = _data_->_inner_error_;
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_data_->_inner_error_ = NULL;
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_error_free0 (_data_->close_err);
#line 1201 "libnotify.c"
		}
		__finally173:
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_simple_async_result_set_from_error (_data_->_async_result, _data_->_inner_error_);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_error_free (_data_->_inner_error_);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->file);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->ins);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->avatar);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_free0 (_data_->body);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_object_unref0 (_data_->primary);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			if (_data_->_state_ == 0) {
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
				g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1224 "libnotify.c"
			} else {
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
				g_simple_async_result_complete (_data_->_async_result);
#line 1228 "libnotify.c"
			}
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_object_unref (_data_->_async_result);
#line 125 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			return FALSE;
#line 1234 "libnotify.c"
		}
#line 131 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (_data_->ins);
#line 131 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_data_->ins = NULL;
#line 1240 "libnotify.c"
	}
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp62_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp62_ = _data_->primary;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp63_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp63_ = geary_rf_c822_mailbox_address_get_short_address (_data_->_tmp62_);
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp64_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp64_ = _data_->_tmp63_;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp65_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp65_ = _data_->body;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp66_ = NULL;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_data_->_tmp66_ = _data_->avatar;
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_issue_current_notification (_data_->self, _data_->_tmp64_, _data_->_tmp65_, _data_->_tmp66_);
#line 134 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_free0 (_data_->_tmp64_);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->file);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->ins);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->avatar);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_free0 (_data_->body);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (_data_->primary);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_data_->_state_ == 0) {
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1280 "libnotify.c"
	} else {
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1284 "libnotify.c"
	}
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_object_unref (_data_->_async_result);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return FALSE;
#line 1290 "libnotify.c"
}


static void libnotify_issue_current_notification (Libnotify* self, const gchar* summary, const gchar* body, GdkPixbuf* icon) {
	NotifyNotification* _tmp0_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GdkPixbuf* _tmp6_ = NULL;
	NotifyNotification* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
#line 137 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 137 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (summary != NULL);
#line 137 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (body != NULL);
#line 137 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail ((icon == NULL) || GDK_IS_PIXBUF (icon));
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->current_notification;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 1313 "libnotify.c"
		{
			NotifyNotification* _tmp1_ = NULL;
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp1_ = self->priv->current_notification;
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			notify_notification_close (_tmp1_, &_inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1322 "libnotify.c"
				goto __catch174_g_error;
			}
		}
		goto __finally174;
		__catch174_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			err = _inner_error_;
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_inner_error_ = NULL;
#line 143 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp2_ = err;
#line 143 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp3_ = _tmp2_->message;
#line 143 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_debug ("libnotify.vala:143: Unable to close current libnotify notification: %s", _tmp3_);
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_error_free0 (err);
#line 1344 "libnotify.c"
		}
		__finally174:
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_clear_error (&_inner_error_);
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			return;
#line 1355 "libnotify.c"
		}
#line 146 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (self->priv->current_notification);
#line 146 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		self->priv->current_notification = NULL;
#line 1361 "libnotify.c"
	}
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp4_ = summary;
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = body;
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = icon;
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp7_ = libnotify_issue_notification (self, "email.arrived", _tmp4_, _tmp5_, _tmp6_, "message-new_email");
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->current_notification);
#line 149 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->current_notification = _tmp7_;
#line 1375 "libnotify.c"
}


static void _libnotify_on_default_action_notify_action_callback (NotifyNotification* notification, const gchar* action, gpointer self) {
#line 165 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_on_default_action ((Libnotify*) self, notification, action);
#line 1382 "libnotify.c"
}


static NotifyNotification* libnotify_issue_notification (Libnotify* self, const gchar* category, const gchar* summary, const gchar* body, GdkPixbuf* icon, const gchar* sound) {
	NotifyNotification* result = NULL;
	GList* _tmp0_ = NULL;
	NotifyNotification* notification = NULL;
	const gchar* _tmp1_ = NULL;
	GObject* _tmp2_ = NULL;
	GObject* _tmp3_ = NULL;
	NotifyNotification* _tmp4_ = NULL;
	GList* _tmp5_ = NULL;
	GCompareFunc _tmp6_ = NULL;
	GList* _tmp7_ = NULL;
	NotifyNotification* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	NotifyNotification* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	NotifyNotification* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	GdkPixbuf* _tmp16_ = NULL;
	const gchar* _tmp19_ = NULL;
	GError * _inner_error_ = NULL;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail (IS_LIBNOTIFY (self), NULL);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail (category != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail (summary != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail (body != NULL, NULL);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_val_if_fail ((icon == NULL) || GDK_IS_PIXBUF (icon), NULL);
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->caps;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_ == NULL) {
#line 156 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		result = NULL;
#line 156 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return result;
#line 1424 "libnotify.c"
	}
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = g_get_application_name ();
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = g_object_new (NOTIFY_TYPE_NOTIFICATION, "icon-name", "geary", "summary", _tmp1_, NULL);
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = G_IS_INITIALLY_UNOWNED (_tmp2_) ? g_object_ref_sink (_tmp2_) : _tmp2_;
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	notification = G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, NOTIFY_TYPE_NOTIFICATION, NotifyNotification);
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp4_ = notification;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	notify_notification_set_hint_string (_tmp4_, "desktop-entry", "geary");
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = self->priv->caps;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = g_strcmp0;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp7_ = g_list_find_custom (_tmp5_, "actions", _tmp6_);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp7_ != NULL) {
#line 1446 "libnotify.c"
		NotifyNotification* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 165 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp8_ = notification;
#line 165 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp9_ = _ ("Open");
#line 165 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		notify_notification_add_action (_tmp8_, "default", _tmp9_, _libnotify_on_default_action_notify_action_callback, g_object_ref (self), g_object_unref);
#line 1455 "libnotify.c"
	}
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp10_ = notification;
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp11_ = category;
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	notify_notification_set_category (_tmp10_, _tmp11_);
#line 168 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp12_ = notification;
#line 168 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp13_ = summary;
#line 168 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, G_TYPE_OBJECT, GObject), "summary", _tmp13_, NULL);
#line 169 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp14_ = notification;
#line 169 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp15_ = body;
#line 169 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_object_set (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, G_TYPE_OBJECT, GObject), "body", _tmp15_, NULL);
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp16_ = icon;
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp16_ != NULL) {
#line 1479 "libnotify.c"
		NotifyNotification* _tmp17_ = NULL;
		GdkPixbuf* _tmp18_ = NULL;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp17_ = notification;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp18_ = icon;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		notify_notification_set_image_from_pixbuf (_tmp17_, _tmp18_);
#line 1488 "libnotify.c"
	}
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp19_ = sound;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp19_ != NULL) {
#line 1494 "libnotify.c"
		GList* _tmp20_ = NULL;
		GList* _tmp21_ = NULL;
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp20_ = self->priv->caps;
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp21_ = g_list_find (_tmp20_, "sound");
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (_tmp21_ != NULL) {
#line 1503 "libnotify.c"
			NotifyNotification* _tmp22_ = NULL;
			const gchar* _tmp23_ = NULL;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp22_ = notification;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp23_ = sound;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			notify_notification_set_hint_string (_tmp22_, "sound-name", _tmp23_);
#line 1512 "libnotify.c"
		} else {
			const gchar* _tmp24_ = NULL;
#line 178 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp24_ = sound;
#line 178 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			libnotify_play_sound (_tmp24_);
#line 1519 "libnotify.c"
		}
	}
	{
		NotifyNotification* _tmp25_ = NULL;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp25_ = notification;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		notify_notification_show (_tmp25_, &_inner_error_);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1530 "libnotify.c"
			goto __catch175_g_error;
		}
	}
	goto __finally175;
	__catch175_g_error:
	{
		GError* err = NULL;
		GError* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		err = _inner_error_;
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_inner_error_ = NULL;
#line 184 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp26_ = err;
#line 184 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_tmp27_ = _tmp26_->message;
#line 184 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_message ("libnotify.vala:184: Unable to show notification: %s", _tmp27_);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_error_free0 (err);
#line 1552 "libnotify.c"
	}
	__finally175:
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (notification);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return NULL;
#line 1565 "libnotify.c"
	}
#line 187 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	result = notification;
#line 187 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return result;
#line 1571 "libnotify.c"
}


void libnotify_play_sound (const gchar* sound) {
	GearyApplication* _tmp0_ = NULL;
	GearyApplication* _tmp1_ = NULL;
	Configuration* _tmp2_ = NULL;
	Configuration* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	ca_context* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
#line 190 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (sound != NULL);
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = geary_application_get_instance ();
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = _tmp0_;
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = geary_application_get_config (_tmp1_);
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = _tmp2_;
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp4_ = configuration_get_play_sounds (_tmp3_);
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp5_ = _tmp4_;
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (!_tmp5_) {
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return;
#line 1602 "libnotify.c"
	}
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_init_sound ();
#line 195 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp6_ = libnotify_sound_context;
#line 195 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp7_ = sound;
#line 195 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	ca_context_play (_tmp6_, (guint32) 0, CA_PROP_EVENT_ID, _tmp7_, NULL);
#line 1612 "libnotify.c"
}


void libnotify_set_error_notification (Libnotify* self, const gchar* summary, const gchar* body) {
	NotifyNotification* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	NotifyNotification* _tmp3_ = NULL;
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (summary != NULL);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (body != NULL);
#line 202 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->error_notification;
#line 202 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 203 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		return;
#line 1633 "libnotify.c"
	}
#line 205 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp1_ = summary;
#line 205 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp2_ = body;
#line 205 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp3_ = libnotify_issue_notification (self, "email", _tmp1_, _tmp2_, NULL, NULL);
#line 205 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 205 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->error_notification = _tmp3_;
#line 1645 "libnotify.c"
}


void libnotify_clear_error_notification (Libnotify* self) {
	NotifyNotification* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (IS_LIBNOTIFY (self));
#line 209 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->error_notification;
#line 209 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (_tmp0_ != NULL) {
#line 1658 "libnotify.c"
		{
			NotifyNotification* _tmp1_ = NULL;
#line 211 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp1_ = self->priv->error_notification;
#line 211 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			notify_notification_close (_tmp1_, &_inner_error_);
#line 211 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1667 "libnotify.c"
				goto __catch176_g_error;
			}
		}
		goto __finally176;
		__catch176_g_error:
		{
			GError* err = NULL;
			GError* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			err = _inner_error_;
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_inner_error_ = NULL;
#line 213 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp2_ = err;
#line 213 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_tmp3_ = _tmp2_->message;
#line 213 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_debug ("libnotify.vala:213: Unable to close libnotify error notification: %s", _tmp3_);
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			_g_error_free0 (err);
#line 1689 "libnotify.c"
		}
		__finally176:
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			g_clear_error (&_inner_error_);
#line 210 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			return;
#line 1700 "libnotify.c"
		}
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		_g_object_unref0 (self->priv->error_notification);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		self->priv->error_notification = NULL;
#line 1706 "libnotify.c"
	}
}


static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_return_if_fail (n_param_values == 3);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		data1 = closure->data;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		data2 = param_values->data[0].v_pointer;
#line 1726 "libnotify.c"
	} else {
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		data1 = param_values->data[0].v_pointer;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		data2 = closure->data;
#line 1732 "libnotify.c"
	}
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 1738 "libnotify.c"
}


static void libnotify_class_init (LibnotifyClass * klass) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	libnotify_parent_class = g_type_class_peek_parent (klass);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_type_class_add_private (klass, sizeof (LibnotifyPrivate));
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	G_OBJECT_CLASS (klass)->finalize = libnotify_finalize;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_signal_new ("invoked", TYPE_LIBNOTIFY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, GEARY_TYPE_FOLDER, GEARY_TYPE_EMAIL);
#line 1751 "libnotify.c"
}


static void libnotify_instance_init (Libnotify * self) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv = LIBNOTIFY_GET_PRIVATE (self);
#line 15 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->current_notification = NULL;
#line 16 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->error_notification = NULL;
#line 17 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->folder = NULL;
#line 18 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->email = NULL;
#line 19 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self->priv->caps = NULL;
#line 1768 "libnotify.c"
}


static void libnotify_finalize (GObject* obj) {
	Libnotify * self;
	NewMessagesMonitor* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LIBNOTIFY, Libnotify);
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_tmp0_ = self->priv->monitor;
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_signal_parse_name ("new-messages-arrived", TYPE_NEW_MESSAGES_MONITOR, &_tmp1_, NULL, FALSE);
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _libnotify_on_new_messages_arrived_new_messages_monitor_new_messages_arrived, self);
#line 14 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->monitor);
#line 15 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->current_notification);
#line 16 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->error_notification);
#line 17 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->folder);
#line 18 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_g_object_unref0 (self->priv->email);
#line 19 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	__g_list_free__g_free0_0 (self->priv->caps);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	G_OBJECT_CLASS (libnotify_parent_class)->finalize (obj);
#line 1798 "libnotify.c"
}


GType libnotify_get_type (void) {
	static volatile gsize libnotify_type_id__volatile = 0;
	if (g_once_init_enter (&libnotify_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LibnotifyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) libnotify_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Libnotify), 0, (GInstanceInitFunc) libnotify_instance_init, NULL };
		GType libnotify_type_id;
		libnotify_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "Libnotify", &g_define_type_info, 0);
		g_once_init_leave (&libnotify_type_id__volatile, libnotify_type_id);
	}
	return libnotify_type_id__volatile;
}



