/* mime-content-type.c generated by valac 0.34.9, the Vala compiler
 * generated from mime-content-type.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gmime/gmime.h>


#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;
typedef struct _GearyBaseObjectPrivate GearyBaseObjectPrivate;

#define GEARY_MIME_TYPE_CONTENT_TYPE (geary_mime_content_type_get_type ())
#define GEARY_MIME_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType))
#define GEARY_MIME_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentTypeClass))
#define GEARY_MIME_IS_CONTENT_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MIME_TYPE_CONTENT_TYPE))
#define GEARY_MIME_IS_CONTENT_TYPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MIME_TYPE_CONTENT_TYPE))
#define GEARY_MIME_CONTENT_TYPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentTypeClass))

typedef struct _GearyMimeContentType GearyMimeContentType;
typedef struct _GearyMimeContentTypeClass GearyMimeContentTypeClass;
typedef struct _GearyMimeContentTypePrivate GearyMimeContentTypePrivate;

#define GEARY_MIME_TYPE_CONTENT_PARAMETERS (geary_mime_content_parameters_get_type ())
#define GEARY_MIME_CONTENT_PARAMETERS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_MIME_TYPE_CONTENT_PARAMETERS, GearyMimeContentParameters))
#define GEARY_MIME_CONTENT_PARAMETERS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_MIME_TYPE_CONTENT_PARAMETERS, GearyMimeContentParametersClass))
#define GEARY_MIME_IS_CONTENT_PARAMETERS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_MIME_TYPE_CONTENT_PARAMETERS))
#define GEARY_MIME_IS_CONTENT_PARAMETERS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_MIME_TYPE_CONTENT_PARAMETERS))
#define GEARY_MIME_CONTENT_PARAMETERS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_MIME_TYPE_CONTENT_PARAMETERS, GearyMimeContentParametersClass))

typedef struct _GearyMimeContentParameters GearyMimeContentParameters;
typedef struct _GearyMimeContentParametersClass GearyMimeContentParametersClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define GEARY_MIME_DATA_FORMAT_TYPE_ENCODING (geary_mime_data_format_encoding_get_type ())
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _GearyBaseObject {
	GObject parent_instance;
	GearyBaseObjectPrivate * priv;
};

struct _GearyBaseObjectClass {
	GObjectClass parent_class;
};

struct _GearyMimeContentType {
	GearyBaseObject parent_instance;
	GearyMimeContentTypePrivate * priv;
};

struct _GearyMimeContentTypeClass {
	GearyBaseObjectClass parent_class;
};

struct _GearyMimeContentTypePrivate {
	gchar* _media_type;
	gchar* _media_subtype;
	GearyMimeContentParameters* _params;
};

typedef enum  {
	GEARY_MIME_ERROR_PARSE
} GearyMimeError;
#define GEARY_MIME_ERROR geary_mime_error_quark ()
typedef enum  {
	GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED,
	GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL,
	GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED
} GearyMimeDataFormatEncoding;


static gpointer geary_mime_content_type_parent_class = NULL;

GType geary_base_object_get_type (void) G_GNUC_CONST;
GType geary_mime_content_type_get_type (void) G_GNUC_CONST;
GType geary_mime_content_parameters_get_type (void) G_GNUC_CONST;
#define GEARY_MIME_CONTENT_TYPE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentTypePrivate))
enum  {
	GEARY_MIME_CONTENT_TYPE_DUMMY_PROPERTY,
	GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE,
	GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE,
	GEARY_MIME_CONTENT_TYPE_PARAMS
};
#define GEARY_MIME_CONTENT_TYPE_WILDCARD "*"
#define GEARY_MIME_CONTENT_TYPE_DEFAULT_CONTENT_TYPE "application/octet-stream"
GearyMimeContentType* geary_mime_content_type_new (const gchar* media_type, const gchar* media_subtype, GearyMimeContentParameters* params);
GearyMimeContentType* geary_mime_content_type_construct (GType object_type, const gchar* media_type, const gchar* media_subtype, GearyMimeContentParameters* params);
GearyBaseObject* geary_base_object_construct (GType object_type);
static void geary_mime_content_type_set_media_type (GearyMimeContentType* self, const gchar* value);
static void geary_mime_content_type_set_media_subtype (GearyMimeContentType* self, const gchar* value);
GearyMimeContentParameters* geary_mime_content_parameters_new (GeeMap* params);
GearyMimeContentParameters* geary_mime_content_parameters_construct (GType object_type, GeeMap* params);
static void geary_mime_content_type_set_params (GearyMimeContentType* self, GearyMimeContentParameters* value);
GearyMimeContentType* geary_mime_content_type_new_from_gmime (GMimeContentType* content_type);
GearyMimeContentType* geary_mime_content_type_construct_from_gmime (GType object_type, GMimeContentType* content_type);
GearyMimeContentParameters* geary_mime_content_parameters_new_from_gmime (GMimeParam* gmime_param);
GearyMimeContentParameters* geary_mime_content_parameters_construct_from_gmime (GType object_type, GMimeParam* gmime_param);
GQuark geary_mime_error_quark (void);
GearyMimeContentType* geary_mime_content_type_deserialize (const gchar* str, GError** error);
gboolean geary_string_is_empty (const gchar* str);
gboolean geary_mime_content_type_has_media_type (GearyMimeContentType* self, const gchar* media_type);
gboolean geary_ascii_stri_equal (const gchar* a, const gchar* b);
const gchar* geary_mime_content_type_get_media_type (GearyMimeContentType* self);
gboolean geary_mime_content_type_has_media_subtype (GearyMimeContentType* self, const gchar* media_subtype);
const gchar* geary_mime_content_type_get_media_subtype (GearyMimeContentType* self);
gchar* geary_mime_content_type_get_mime_type (GearyMimeContentType* self);
gboolean geary_mime_content_type_is_type (GearyMimeContentType* self, const gchar* media_type, const gchar* media_subtype);
gboolean geary_mime_content_type_is_same (GearyMimeContentType* self, GearyMimeContentType* other);
gboolean geary_mime_content_type_is_mime_type (GearyMimeContentType* self, const gchar* mime_type, GError** error);
gchar* geary_mime_content_type_serialize (GearyMimeContentType* self);
GearyMimeContentParameters* geary_mime_content_type_get_params (GearyMimeContentType* self);
gint geary_mime_content_parameters_get_size (GearyMimeContentParameters* self);
GeeCollection* geary_mime_content_parameters_get_attributes (GearyMimeContentParameters* self);
gchar* geary_mime_content_parameters_get_value (GearyMimeContentParameters* self, const gchar* attribute);
GType geary_mime_data_format_encoding_get_type (void) G_GNUC_CONST;
GearyMimeDataFormatEncoding geary_mime_data_format_get_encoding_requirement (const gchar* str);
gchar* geary_mime_content_type_to_string (GearyMimeContentType* self);
static void geary_mime_content_type_finalize (GObject* obj);
static void _vala_geary_mime_content_type_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_geary_mime_content_type_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
     * Create a MIME Content-Type representative object.
     */
static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1215 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1216 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1216 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1217 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1217 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1218 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _result_;
#line 1218 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 164 "mime-content-type.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return self ? g_object_ref (self) : NULL;
#line 171 "mime-content-type.c"
}


GearyMimeContentType* geary_mime_content_type_construct (GType object_type, const gchar* media_type, const gchar* media_subtype, GearyMimeContentParameters* params) {
	GearyMimeContentType * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	GearyMimeContentParameters* _tmp6_ = NULL;
	GearyMimeContentParameters* _tmp7_ = NULL;
	GearyMimeContentParameters* _tmp8_ = NULL;
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, NULL);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, NULL);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail ((params == NULL) || GEARY_MIME_IS_CONTENT_PARAMETERS (params), NULL);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self = (GearyMimeContentType*) geary_base_object_construct (object_type);
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = media_type;
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = string_strip (_tmp0_);
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = _tmp1_;
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_type (self, _tmp2_);
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp2_);
#line 63 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp3_ = media_subtype;
#line 63 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 63 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp5_ = _tmp4_;
#line 63 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_subtype (self, _tmp5_);
#line 63 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp5_);
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp7_ = params;
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp8_ = _g_object_ref0 (_tmp7_);
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp6_ = _tmp8_;
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp6_ == NULL) {
#line 222 "mime-content-type.c"
		GearyMimeContentParameters* _tmp9_ = NULL;
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp9_ = geary_mime_content_parameters_new (NULL);
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_g_object_unref0 (_tmp6_);
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp6_ = _tmp9_;
#line 230 "mime-content-type.c"
	}
#line 64 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_params (self, _tmp6_);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp6_);
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return self;
#line 238 "mime-content-type.c"
}


GearyMimeContentType* geary_mime_content_type_new (const gchar* media_type, const gchar* media_subtype, GearyMimeContentParameters* params) {
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return geary_mime_content_type_construct (GEARY_MIME_TYPE_CONTENT_TYPE, media_type, media_subtype, params);
#line 245 "mime-content-type.c"
}


GearyMimeContentType* geary_mime_content_type_construct_from_gmime (GType object_type, GMimeContentType* content_type) {
	GearyMimeContentType * self = NULL;
	GMimeContentType* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GMimeContentType* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GMimeContentType* _tmp8_ = NULL;
	GMimeParam* _tmp9_ = NULL;
	GearyMimeContentParameters* _tmp10_ = NULL;
	GearyMimeContentParameters* _tmp11_ = NULL;
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GMIME_IS_CONTENT_TYPE (content_type), NULL);
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self = (GearyMimeContentType*) geary_base_object_construct (object_type);
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = content_type;
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = g_mime_content_type_get_media_type (_tmp0_);
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp3_ = _tmp2_;
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_type (self, _tmp3_);
#line 68 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp3_);
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp4_ = content_type;
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp5_ = g_mime_content_type_get_media_subtype (_tmp4_);
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp7_ = _tmp6_;
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_media_subtype (self, _tmp7_);
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp7_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp8_ = content_type;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp9_ = g_mime_content_type_get_params (_tmp8_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp10_ = geary_mime_content_parameters_new_from_gmime (_tmp9_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp11_ = _tmp10_;
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_set_params (self, _tmp11_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp11_);
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return self;
#line 305 "mime-content-type.c"
}


GearyMimeContentType* geary_mime_content_type_new_from_gmime (GMimeContentType* content_type) {
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return geary_mime_content_type_construct_from_gmime (GEARY_MIME_TYPE_CONTENT_TYPE, content_type);
#line 312 "mime-content-type.c"
}


static gboolean string_contains (const gchar* self, const gchar* needle) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 1384 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1384 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1385 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = needle;
#line 1385 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = strstr ((gchar*) self, (gchar*) _tmp0_);
#line 1385 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp1_ != NULL;
#line 1385 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 332 "mime-content-type.c"
}


GearyMimeContentType* geary_mime_content_type_deserialize (const gchar* str, GError** error) {
	GearyMimeContentType* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp7_ = NULL;
	GMimeContentType* _tmp8_ = NULL;
	GMimeContentType* _tmp9_ = NULL;
	GearyMimeContentType* _tmp10_ = NULL;
	GearyMimeContentType* _tmp11_ = NULL;
	GError * _inner_error_ = NULL;
#line 73 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = str;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = geary_string_is_empty (_tmp0_);
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp1_) {
#line 356 "mime-content-type.c"
		GError* _tmp2_ = NULL;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp2_ = g_error_new_literal (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Empty MIME Content-Type");
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_inner_error_ = _tmp2_;
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		if (_inner_error_->domain == GEARY_MIME_ERROR) {
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error_);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return NULL;
#line 368 "mime-content-type.c"
		} else {
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return NULL;
#line 376 "mime-content-type.c"
		}
	}
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp3_ = str;
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp4_ = string_contains (_tmp3_, "/");
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (!_tmp4_) {
#line 385 "mime-content-type.c"
		const gchar* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp5_ = str;
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp6_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME Content-Type: %s", _tmp5_);
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_inner_error_ = _tmp6_;
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		if (_inner_error_->domain == GEARY_MIME_ERROR) {
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error_);
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return NULL;
#line 400 "mime-content-type.c"
		} else {
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error_);
#line 80 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return NULL;
#line 408 "mime-content-type.c"
		}
	}
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp7_ = str;
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp8_ = g_mime_content_type_new_from_string (_tmp7_);
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp9_ = _tmp8_;
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp10_ = geary_mime_content_type_new_from_gmime (_tmp9_);
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp11_ = _tmp10_;
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (_tmp9_);
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp11_;
#line 82 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 427 "mime-content-type.c"
}


/**
     * Compares the {@link media_type} with the supplied type.
     *
     * An asterisk ("*") or {@link WILDCARD} are accepted, which will always return true.
     *
     * @see is_type
     */
gboolean geary_mime_content_type_has_media_type (GearyMimeContentType* self, const gchar* media_type) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 92 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, FALSE);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = media_type;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (_tmp1_, GEARY_MIME_CONTENT_TYPE_WILDCARD) != 0) {
#line 450 "mime-content-type.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp2_ = self->priv->_media_type;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp3_ = media_type;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = geary_ascii_stri_equal (_tmp2_, _tmp3_);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = _tmp4_;
#line 462 "mime-content-type.c"
	} else {
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = TRUE;
#line 466 "mime-content-type.c"
	}
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 472 "mime-content-type.c"
}


/**
     * Compares the {@link media_subtype} with the supplied subtype.
     *
     * An asterisk ("*") or {@link WILDCARD} are accepted, which will always return true.
     *
     * @see is_type
     */
gboolean geary_mime_content_type_has_media_subtype (GearyMimeContentType* self, const gchar* media_subtype) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, FALSE);
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = media_subtype;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (g_strcmp0 (_tmp1_, GEARY_MIME_CONTENT_TYPE_WILDCARD) != 0) {
#line 495 "mime-content-type.c"
		const gchar* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp2_ = self->priv->_media_subtype;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp3_ = media_subtype;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = geary_ascii_stri_equal (_tmp2_, _tmp3_);
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = _tmp4_;
#line 507 "mime-content-type.c"
	} else {
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = TRUE;
#line 511 "mime-content-type.c"
	}
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 517 "mime-content-type.c"
}


/**
     * Returns the {@link ContentType}'s media content type (its "MIME type").
     *
     * This returns the bare MIME content type description lacking all parameters.  For example,
     * "image/jpeg; name='photo.JPG'" will be returned as "image/jpeg".
     *
     * @see serialize
     */
gchar* geary_mime_content_type_get_mime_type (GearyMimeContentType* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 115 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_type;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = self->priv->_media_subtype;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = g_strdup_printf ("%s/%s", _tmp0_, _tmp1_);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp2_;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 546 "mime-content-type.c"
}


/**
     * Compares the supplied type and subtype with this instance's.
     *
     * Asterisks (or {@link WILDCARD}) may be supplied for either field.
     *
     * @see is_same
     */
gboolean geary_mime_content_type_is_type (GearyMimeContentType* self, const gchar* media_type, const gchar* media_subtype) {
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_type != NULL, FALSE);
#line 126 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (media_subtype != NULL, FALSE);
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = media_type;
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = geary_mime_content_type_has_media_type (self, _tmp1_);
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp2_) {
#line 574 "mime-content-type.c"
		const gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp3_ = media_subtype;
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = geary_mime_content_type_has_media_subtype (self, _tmp3_);
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = _tmp4_;
#line 583 "mime-content-type.c"
	} else {
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp0_ = FALSE;
#line 587 "mime-content-type.c"
	}
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 127 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 593 "mime-content-type.c"
}


/**
     * Compares this {@link ContentType} with another instance.
     *
     * This is slightly different than the notion of "equal to", as it's possible for
     * {@link ContentType} to hold {@link WILDCARD}s, which don't imply equality.
     *
     * @see is_type
     */
gboolean geary_mime_content_type_is_same (GearyMimeContentType* self, GearyMimeContentType* other) {
	gboolean result = FALSE;
	GearyMimeContentType* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	GearyMimeContentType* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
#line 138 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 138 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (other), FALSE);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = other;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = _tmp0_->priv->_media_type;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = other;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp3_ = _tmp2_->priv->_media_subtype;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp4_ = geary_mime_content_type_is_type (self, _tmp1_, _tmp3_);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp4_;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 630 "mime-content-type.c"
}


/**
     * Compares the supplied MIME type (i.e. "image/jpeg") with this instance.
     *
     * As in {@link get_mime_type}, this method is only worried about the media type and subtype
     * in the supplied string.  Parameters are ignored.
     *
     * Throws {@link MimeError} if the supplied string doesn't look like a MIME type.
     */
static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1015 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1016 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1016 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 1016 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strchr (((gchar*) self) + _tmp0_, (gssize) -1, _tmp1_);
#line 1016 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1018 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1018 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 663 "mime-content-type.c"
		gchar* _tmp4_ = NULL;
#line 1019 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1019 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1019 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 671 "mime-content-type.c"
	} else {
#line 1021 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = -1;
#line 1021 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 677 "mime-content-type.c"
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 701 "mime-content-type.c"
		glong _tmp4_ = 0L;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 709 "mime-content-type.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 721 "mime-content-type.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1314 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 745 "mime-content-type.c"
		glong _tmp2_ = 0L;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 751 "mime-content-type.c"
	} else {
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 755 "mime-content-type.c"
	}
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 759 "mime-content-type.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 771 "mime-content-type.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 781 "mime-content-type.c"
	}
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 787 "mime-content-type.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 801 "mime-content-type.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 811 "mime-content-type.c"
	}
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 817 "mime-content-type.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 826 "mime-content-type.c"
	}
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 846 "mime-content-type.c"
}


gboolean geary_mime_content_type_is_mime_type (GearyMimeContentType* self, const gchar* mime_type, GError** error) {
	gboolean result = FALSE;
	gint index = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gchar* mime_media_type = NULL;
	const gchar* _tmp7_ = NULL;
	gint _tmp8_ = 0;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* mime_media_subtype = NULL;
	const gchar* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gint _tmp17_ = 0;
	gint _tmp18_ = 0;
	const gchar* _tmp22_ = NULL;
	gchar* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	const gchar* _tmp25_ = NULL;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp33_ = NULL;
	const gchar* _tmp34_ = NULL;
	gboolean _tmp35_ = FALSE;
	GError * _inner_error_ = NULL;
#line 150 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), FALSE);
#line 150 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (mime_type != NULL, FALSE);
#line 151 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = mime_type;
#line 151 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = string_index_of_char (_tmp0_, (gunichar) '/', 0);
#line 151 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	index = _tmp1_;
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = index;
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp2_ < 0) {
#line 893 "mime-content-type.c"
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp3_ = mime_type;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME type: %s", _tmp3_);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_inner_error_ = _tmp4_;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		if (_inner_error_->domain == GEARY_MIME_ERROR) {
#line 904 "mime-content-type.c"
			gboolean _tmp5_ = FALSE;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error_);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return _tmp5_;
#line 910 "mime-content-type.c"
		} else {
			gboolean _tmp6_ = FALSE;
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error_);
#line 153 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return _tmp6_;
#line 919 "mime-content-type.c"
		}
	}
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp7_ = mime_type;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp8_ = index;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp9_ = string_substring (_tmp7_, (glong) 0, (glong) _tmp8_);
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp10_ = _tmp9_;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp11_ = string_strip (_tmp10_);
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp12_ = _tmp11_;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (_tmp10_);
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	mime_media_type = _tmp12_;
#line 157 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp13_ = mime_type;
#line 157 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp14_ = index;
#line 157 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp15_ = string_substring (_tmp13_, (glong) (_tmp14_ + 1), (glong) -1);
#line 157 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	mime_media_subtype = _tmp15_;
#line 158 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp16_ = mime_media_subtype;
#line 158 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp17_ = string_index_of_char (_tmp16_, (gunichar) ';', 0);
#line 158 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	index = _tmp17_;
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp18_ = index;
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp18_ >= 0) {
#line 956 "mime-content-type.c"
		const gchar* _tmp19_ = NULL;
		gint _tmp20_ = 0;
		gchar* _tmp21_ = NULL;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp19_ = mime_media_subtype;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp20_ = index;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp21_ = string_substring (_tmp19_, (glong) 0, (glong) _tmp20_);
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_g_free0 (mime_media_subtype);
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		mime_media_subtype = _tmp21_;
#line 970 "mime-content-type.c"
	}
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp22_ = mime_media_subtype;
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp23_ = string_strip (_tmp22_);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_subtype);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	mime_media_subtype = _tmp23_;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp25_ = mime_media_type;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp26_ = geary_string_is_empty (_tmp25_);
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp26_) {
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp24_ = TRUE;
#line 988 "mime-content-type.c"
	} else {
		const gchar* _tmp27_ = NULL;
		gboolean _tmp28_ = FALSE;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp27_ = mime_media_subtype;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp28_ = geary_string_is_empty (_tmp27_);
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp24_ = _tmp28_;
#line 998 "mime-content-type.c"
	}
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp24_) {
#line 1002 "mime-content-type.c"
		const gchar* _tmp29_ = NULL;
		GError* _tmp30_ = NULL;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp29_ = mime_type;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp30_ = g_error_new (GEARY_MIME_ERROR, GEARY_MIME_ERROR_PARSE, "Invalid MIME type: %s", _tmp29_);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_inner_error_ = _tmp30_;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		if (_inner_error_->domain == GEARY_MIME_ERROR) {
#line 1013 "mime-content-type.c"
			gboolean _tmp31_ = FALSE;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_propagate_error (error, _inner_error_);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_subtype);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_type);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return _tmp31_;
#line 1023 "mime-content-type.c"
		} else {
			gboolean _tmp32_ = FALSE;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_subtype);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_free0 (mime_media_type);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			g_clear_error (&_inner_error_);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			return _tmp32_;
#line 1036 "mime-content-type.c"
		}
	}
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp33_ = mime_media_type;
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp34_ = mime_media_subtype;
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp35_ = geary_mime_content_type_is_type (self, _tmp33_, _tmp34_);
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp35_;
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_subtype);
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (mime_media_type);
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1053 "mime-content-type.c"
}


gchar* geary_mime_content_type_serialize (GearyMimeContentType* self) {
	gchar* result = NULL;
	GString* builder = NULL;
	GString* _tmp0_ = NULL;
	GString* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GearyMimeContentParameters* _tmp5_ = NULL;
	GString* _tmp32_ = NULL;
	const gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
#line 169 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = g_string_new ("");
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	builder = _tmp0_;
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = builder;
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp2_ = self->priv->_media_type;
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp3_ = self->priv->_media_subtype;
#line 171 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_string_append_printf (_tmp1_, "%s/%s", _tmp2_, _tmp3_);
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp5_ = self->priv->_params;
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp5_ != NULL) {
#line 1087 "mime-content-type.c"
		GearyMimeContentParameters* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp6_ = self->priv->_params;
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp7_ = geary_mime_content_parameters_get_size (_tmp6_);
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp8_ = _tmp7_;
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = _tmp8_ > 0;
#line 1099 "mime-content-type.c"
	} else {
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		_tmp4_ = FALSE;
#line 1103 "mime-content-type.c"
	}
#line 173 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	if (_tmp4_) {
#line 1107 "mime-content-type.c"
		{
			GeeIterator* _attribute_it = NULL;
			GearyMimeContentParameters* _tmp9_ = NULL;
			GeeCollection* _tmp10_ = NULL;
			GeeCollection* _tmp11_ = NULL;
			GeeCollection* _tmp12_ = NULL;
			GeeIterator* _tmp13_ = NULL;
			GeeIterator* _tmp14_ = NULL;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp9_ = self->priv->_params;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp10_ = geary_mime_content_parameters_get_attributes (_tmp9_);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp11_ = _tmp10_;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp12_ = _tmp11_;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp13_ = gee_iterable_iterator (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ITERABLE, GeeIterable));
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_tmp14_ = _tmp13_;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_object_unref0 (_tmp12_);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_attribute_it = _tmp14_;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			while (TRUE) {
#line 1134 "mime-content-type.c"
				GeeIterator* _tmp15_ = NULL;
				gboolean _tmp16_ = FALSE;
				gchar* attribute = NULL;
				GeeIterator* _tmp17_ = NULL;
				gpointer _tmp18_ = NULL;
				gchar* value = NULL;
				GearyMimeContentParameters* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				const gchar* _tmp22_ = NULL;
				GearyMimeDataFormatEncoding _tmp23_ = 0;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp15_ = _attribute_it;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp16_ = gee_iterator_next (_tmp15_);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				if (!_tmp16_) {
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
					break;
#line 1154 "mime-content-type.c"
				}
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp17_ = _attribute_it;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp18_ = gee_iterator_get (_tmp17_);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				attribute = (gchar*) _tmp18_;
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp19_ = self->priv->_params;
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp20_ = attribute;
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp21_ = geary_mime_content_parameters_get_value (_tmp19_, _tmp20_);
#line 175 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				value = _tmp21_;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp22_ = value;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_tmp23_ = geary_mime_data_format_get_encoding_requirement (_tmp22_);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				switch (_tmp23_) {
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_OPTIONAL:
#line 1178 "mime-content-type.c"
					{
						GString* _tmp24_ = NULL;
						const gchar* _tmp25_ = NULL;
						const gchar* _tmp26_ = NULL;
#line 179 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp24_ = builder;
#line 179 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp25_ = attribute;
#line 179 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp26_ = value;
#line 179 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						g_string_append_printf (_tmp24_, "; %s=%s", _tmp25_, _tmp26_);
#line 180 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						break;
#line 1193 "mime-content-type.c"
					}
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_QUOTING_REQUIRED:
#line 1197 "mime-content-type.c"
					{
						GString* _tmp27_ = NULL;
						const gchar* _tmp28_ = NULL;
						const gchar* _tmp29_ = NULL;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp27_ = builder;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp28_ = attribute;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp29_ = value;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						g_string_append_printf (_tmp27_, "; %s=\"%s\"", _tmp28_, _tmp29_);
#line 184 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						break;
#line 1212 "mime-content-type.c"
					}
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
					case GEARY_MIME_DATA_FORMAT_ENCODING_UNALLOWED:
#line 1216 "mime-content-type.c"
					{
						const gchar* _tmp30_ = NULL;
						const gchar* _tmp31_ = NULL;
#line 187 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp30_ = attribute;
#line 187 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						_tmp31_ = value;
#line 187 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						g_message ("mime-content-type.vala:187: Cannot encode ContentType param value %s=\"" \
"%s\": unallowed", _tmp30_, _tmp31_);
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						break;
#line 1228 "mime-content-type.c"
					}
					default:
					{
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
						g_assert_not_reached ();
#line 1234 "mime-content-type.c"
					}
				}
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_g_free0 (value);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
				_g_free0 (attribute);
#line 1241 "mime-content-type.c"
			}
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
			_g_object_unref0 (_attribute_it);
#line 1245 "mime-content-type.c"
		}
	}
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp32_ = builder;
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp33_ = _tmp32_->str;
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp34_ = g_strdup (_tmp33_);
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp34_;
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_string_free0 (builder);
#line 197 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1260 "mime-content-type.c"
}


gchar* geary_mime_content_type_to_string (GearyMimeContentType* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 200 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = geary_mime_content_type_serialize (self);
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1275 "mime-content-type.c"
}


const gchar* geary_mime_content_type_get_media_type (GearyMimeContentType* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_type;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1290 "mime-content-type.c"
}


static void geary_mime_content_type_set_media_type (GearyMimeContentType* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = value;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_type);
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self->priv->_media_type = _tmp1_;
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_notify ((GObject *) self, "media-type");
#line 1309 "mime-content-type.c"
}


const gchar* geary_mime_content_type_get_media_subtype (GearyMimeContentType* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_media_subtype;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1324 "mime-content-type.c"
}


static void geary_mime_content_type_set_media_subtype (GearyMimeContentType* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = value;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_subtype);
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self->priv->_media_subtype = _tmp1_;
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_notify ((GObject *) self, "media-subtype");
#line 1343 "mime-content-type.c"
}


GearyMimeContentParameters* geary_mime_content_type_get_params (GearyMimeContentType* self) {
	GearyMimeContentParameters* result;
	GearyMimeContentParameters* _tmp0_ = NULL;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_val_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self), NULL);
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = self->priv->_params;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	result = _tmp0_;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	return result;
#line 1358 "mime-content-type.c"
}


static void geary_mime_content_type_set_params (GearyMimeContentType* self, GearyMimeContentParameters* value) {
	GearyMimeContentParameters* _tmp0_ = NULL;
	GearyMimeContentParameters* _tmp1_ = NULL;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_return_if_fail (GEARY_MIME_IS_CONTENT_TYPE (self));
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp0_ = value;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (self->priv->_params);
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self->priv->_params = _tmp1_;
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_notify ((GObject *) self, "params");
#line 1377 "mime-content-type.c"
}


static void geary_mime_content_type_class_init (GearyMimeContentTypeClass * klass) {
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	geary_mime_content_type_parent_class = g_type_class_peek_parent (klass);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_type_class_add_private (klass, sizeof (GearyMimeContentTypePrivate));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_geary_mime_content_type_get_property;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_geary_mime_content_type_set_property;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (klass)->finalize = geary_mime_content_type_finalize;
#line 1392 "mime-content-type.c"
	/**
	     * The type (discrete or concrete) portion of the Content-Type field.
	     *
	     * It's highly recommended the caller use the various ''has'' and ''is'' methods when performing
	     * comparisons rather than direct string operations.
	     *
	     * media_type may be {@link WILDCARD}, in which case it matches with any other media_type.
	     *
	     * @see has_media_type
	     */
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE, g_param_spec_string ("media-type", "media-type", "media-type", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1405 "mime-content-type.c"
	/**
	     * The subtype (extension-token or iana-token) portion of the Content-Type field.
	     *
	     * It's highly recommended the caller use the various ''has'' and ''is'' methods when performing
	     * comparisons rather than direct string operations.
	     *
	     * media_subtype may be {@link WILDCARD}, in which case it matches with any other media_subtype.
	     *
	     * @see has_media_subtype
	     */
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE, g_param_spec_string ("media-subtype", "media-subtype", "media-subtype", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1418 "mime-content-type.c"
	/**
	     * Content parameters, if any, in the Content-Type field.
	     *
	     * This is never null.  Rather, an empty ContentParameters is held if the Content-Type has
	     * no parameters.
	     */
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GEARY_MIME_CONTENT_TYPE_PARAMS, g_param_spec_object ("params", "params", "params", GEARY_MIME_TYPE_CONTENT_PARAMETERS, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 1427 "mime-content-type.c"
}


static void geary_mime_content_type_instance_init (GearyMimeContentType * self) {
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self->priv = GEARY_MIME_CONTENT_TYPE_GET_PRIVATE (self);
#line 1434 "mime-content-type.c"
}


static void geary_mime_content_type_finalize (GObject* obj) {
	GearyMimeContentType * self;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 36 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_type);
#line 48 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_free0 (self->priv->_media_subtype);
#line 56 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	_g_object_unref0 (self->priv->_params);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	G_OBJECT_CLASS (geary_mime_content_type_parent_class)->finalize (obj);
#line 1450 "mime-content-type.c"
}


/**
 * A representation of an RFC 2045 MIME Content-Type field.
 *
 * See [[https://tools.ietf.org/html/rfc2045#section-5]]
 */
GType geary_mime_content_type_get_type (void) {
	static volatile gsize geary_mime_content_type_type_id__volatile = 0;
	if (g_once_init_enter (&geary_mime_content_type_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GearyMimeContentTypeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) geary_mime_content_type_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GearyMimeContentType), 0, (GInstanceInitFunc) geary_mime_content_type_instance_init, NULL };
		GType geary_mime_content_type_type_id;
		geary_mime_content_type_type_id = g_type_register_static (GEARY_TYPE_BASE_OBJECT, "GearyMimeContentType", &g_define_type_info, 0);
		g_once_init_leave (&geary_mime_content_type_type_id__volatile, geary_mime_content_type_type_id);
	}
	return geary_mime_content_type_type_id__volatile;
}


static void _vala_geary_mime_content_type_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	GearyMimeContentType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	switch (property_id) {
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		g_value_set_string (value, geary_mime_content_type_get_media_type (self));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		g_value_set_string (value, geary_mime_content_type_get_media_subtype (self));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_PARAMS:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		g_value_set_object (value, geary_mime_content_type_get_params (self));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 1494 "mime-content-type.c"
		default:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 1500 "mime-content-type.c"
	}
}


static void _vala_geary_mime_content_type_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	GearyMimeContentType * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, GEARY_MIME_TYPE_CONTENT_TYPE, GearyMimeContentType);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
	switch (property_id) {
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_TYPE:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_media_type (self, g_value_get_string (value));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_MEDIA_SUBTYPE:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_media_subtype (self, g_value_get_string (value));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		case GEARY_MIME_CONTENT_TYPE_PARAMS:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		geary_mime_content_type_set_params (self, g_value_get_object (value));
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 1528 "mime-content-type.c"
		default:
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "/builddir/build/BUILD/geary-0.11.4/src/engine/mime/mime-content-type.vala"
		break;
#line 1534 "mime-content-type.c"
	}
}



