/* util-webkit.c generated by valac 0.34.9, the Vala compiler
 * generated from util-webkit.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* Regex to detect URLs.*/
/* Originally from here: http://daringfireball.net/2010/07/improved_regex_for_matching_urls*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "webkit/webkit.h"
#include "geary-static.h"
#include <gee.h>

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef struct _Block17Data Block17Data;

struct _Block17Data {
	int _ref_count_;
	gchar** values;
	gint values_length1;
};



#define URL_REGEX "(?i)\\b((?:[a-z][\\w-]+:(?:/{1,3}|[a-z0-9%])|www\\d{0,3}[.]|[a-z0-9.\\" \
"-]+[.][a-z]{2,4}/)(?:[^\\s()<>]+|\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*" \
"\\))+(?:\\(([^\\s()<>]+|(\\([^\\s()<>]+\\)))*\\)|[^\\s`!()\\[\\]{};:'\"" \
".,<>?«»“”‘’]))"
#define PROTOCOL_REGEX "^(aim|apt|bitcoin|cvs|ed2k|ftp|file|finger|git|gtalk|http|https|irc|ir" \
"cs|irc6|lastfm|ldap|ldaps|magnet|news|nntp|rsync|sftp|skype|smb|sms|sv" \
"n|telnet|tftp|ssh|webcal|xmpp):"
#define QUOTE_START ""
#define QUOTE_END ""
WebKitDOMHTMLElement* util_dom_select (WebKitDOMNode* node, const gchar* selector);
WebKitDOMHTMLElement* util_dom_clone_node (WebKitDOMNode* node, gboolean deep);
WebKitDOMHTMLElement* util_dom_clone_select (WebKitDOMNode* node, const gchar* selector, gboolean deep);
void util_dom_toggle_class (WebKitDOMDOMTokenList* class_list, const gchar* clas, gboolean add, GError** error);
gchar* util_dom_get_text_representation (WebKitDOMDocument* doc, const gchar* exclude);
void bind_event (WebKitWebView* view, const gchar* selector, const gchar* event, GCallback callback, GObject* extra);
void linkify_document (WebKitDOMDocument* document);
void linkify_recurse (WebKitDOMDocument* document, WebKitDOMNode* node, gboolean _in_link);
gboolean pre_split_urls (GMatchInfo* match_info, GString* _result_);
static gboolean _pre_split_urls_gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self);
gboolean is_valid_url (GMatchInfo* match_info, GString* _result_);
gchar* linkify_and_escape_plain_text (const gchar* input, GError** error);
static gboolean _is_valid_url_gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self);
gboolean node_is_child_of (WebKitDOMNode* node, const gchar* ancestor_tag);
WebKitDOMHTMLElement* closest_ancestor (WebKitDOMElement* element, const gchar* selector);
gboolean is_descendant_of (WebKitDOMElement* element, const gchar* selector);
gchar* decorate_quotes (const gchar* text, GError** error);
gchar* html_to_flowed_text (WebKitDOMHTMLElement* el);
gchar* resolve_nesting (const gchar* text, gchar** values, int values_length1);
gchar* quote_lines (const gchar* text);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda47_ (Block17Data* _data17_, GMatchInfo* info, GString* res);
static gboolean ____lambda47__gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self);
gchar* assemble_data_uri (const gchar* mimetype, GearyMemoryBuffer* buffer);
gboolean dissasemble_data_uri (const gchar* uri, GearyMemoryBuffer** buffer);
gchar* smart_escape (const gchar* text, gboolean preserve_whitespace_in_html);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static gpointer _g_object_ref0 (gpointer self) {
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return self ? g_object_ref (self) : NULL;
#line 76 "util-webkit.c"
}


WebKitDOMHTMLElement* util_dom_select (WebKitDOMNode* node, const gchar* selector) {
	WebKitDOMHTMLElement* result = NULL;
	GError * _inner_error_ = NULL;
#line 20 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_NODE (node), NULL);
#line 20 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (selector != NULL, NULL);
#line 87 "util-webkit.c"
	{
		WebKitDOMNode* _tmp0_ = NULL;
#line 22 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp0_ = node;
#line 22 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, webkit_dom_document_get_type ())) {
#line 94 "util-webkit.c"
			WebKitDOMElement* _tmp1_ = NULL;
			WebKitDOMNode* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			WebKitDOMElement* _tmp4_ = NULL;
			WebKitDOMHTMLElement* _tmp5_ = NULL;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp2_ = node;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = selector;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp4_ = webkit_dom_document_query_selector (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, webkit_dom_document_get_type ()) ? ((WebKitDOMDocument*) _tmp2_) : NULL, _tmp3_, &_inner_error_);
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp1_ = _tmp4_;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 110 "util-webkit.c"
				goto __catch179_g_error;
			}
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, webkit_dom_html_element_get_type ()) ? ((WebKitDOMHTMLElement*) _tmp1_) : NULL);
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			result = _tmp5_;
#line 23 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return result;
#line 119 "util-webkit.c"
		} else {
			WebKitDOMElement* _tmp6_ = NULL;
			WebKitDOMNode* _tmp7_ = NULL;
			const gchar* _tmp8_ = NULL;
			WebKitDOMElement* _tmp9_ = NULL;
			WebKitDOMHTMLElement* _tmp10_ = NULL;
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp7_ = node;
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp8_ = selector;
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp9_ = webkit_dom_element_query_selector (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, webkit_dom_element_get_type ()) ? ((WebKitDOMElement*) _tmp7_) : NULL, _tmp8_, &_inner_error_);
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp6_ = _tmp9_;
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 136 "util-webkit.c"
				goto __catch179_g_error;
			}
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, webkit_dom_html_element_get_type ()) ? ((WebKitDOMHTMLElement*) _tmp6_) : NULL);
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			result = _tmp10_;
#line 25 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return result;
#line 145 "util-webkit.c"
		}
	}
	goto __finally179;
	__catch179_g_error:
	{
		GError* _error_ = NULL;
		const gchar* _tmp11_ = NULL;
		GError* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 21 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 21 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp11_ = selector;
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp12_ = _error_;
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp13_ = _tmp12_->message;
#line 28 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:28: Error selecting element %s: %s", _tmp11_, _tmp13_);
#line 29 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = NULL;
#line 29 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 29 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 173 "util-webkit.c"
	}
	__finally179:
#line 21 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 21 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_clear_error (&_inner_error_);
#line 21 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return NULL;
#line 182 "util-webkit.c"
}


WebKitDOMHTMLElement* util_dom_clone_node (WebKitDOMNode* node, gboolean deep) {
	WebKitDOMHTMLElement* result = NULL;
	WebKitDOMNode* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	WebKitDOMNode* _tmp2_ = NULL;
	WebKitDOMHTMLElement* _tmp3_ = NULL;
#line 33 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_NODE (node), NULL);
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = node;
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = deep;
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = webkit_dom_node_clone_node (_tmp0_, _tmp1_);
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, webkit_dom_html_element_get_type ()) ? ((WebKitDOMHTMLElement*) _tmp2_) : NULL);
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp3_;
#line 34 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 206 "util-webkit.c"
}


WebKitDOMHTMLElement* util_dom_clone_select (WebKitDOMNode* node, const gchar* selector, gboolean deep) {
	WebKitDOMHTMLElement* result = NULL;
	WebKitDOMNode* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	WebKitDOMHTMLElement* _tmp2_ = NULL;
	WebKitDOMHTMLElement* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	WebKitDOMHTMLElement* _tmp5_ = NULL;
	WebKitDOMHTMLElement* _tmp6_ = NULL;
#line 37 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_NODE (node), NULL);
#line 37 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (selector != NULL, NULL);
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = node;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = selector;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = util_dom_select (_tmp0_, _tmp1_);
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = _tmp2_;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = deep;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = util_dom_clone_node (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, webkit_dom_node_get_type (), WebKitDOMNode), _tmp4_);
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp6_ = _tmp5_;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (_tmp3_);
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp6_;
#line 39 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 243 "util-webkit.c"
}


void util_dom_toggle_class (WebKitDOMDOMTokenList* class_list, const gchar* clas, gboolean add, GError** error) {
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (WEBKIT_DOM_IS_DOM_TOKEN_LIST (class_list));
#line 42 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (clas != NULL);
#line 43 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = add;
#line 43 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp0_) {
#line 258 "util-webkit.c"
		WebKitDOMDOMTokenList* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = class_list;
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = clas;
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		webkit_dom_dom_token_list_add (_tmp1_, _tmp2_, &_inner_error_);
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 44 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return;
#line 273 "util-webkit.c"
		}
	} else {
		WebKitDOMDOMTokenList* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = class_list;
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = clas;
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		webkit_dom_dom_token_list_remove (_tmp3_, _tmp4_, &_inner_error_);
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_propagate_error (error, _inner_error_);
#line 46 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return;
#line 290 "util-webkit.c"
		}
	}
}


gchar* util_dom_get_text_representation (WebKitDOMDocument* doc, const gchar* exclude) {
	gchar* result = NULL;
	WebKitDOMHTMLElement* copy = NULL;
	WebKitDOMDocument* _tmp0_ = NULL;
	WebKitDOMHTMLElement* _tmp1_ = NULL;
	WebKitDOMHTMLElement* _tmp2_ = NULL;
	WebKitDOMHTMLElement* _tmp3_ = NULL;
	WebKitDOMNodeList* node_list = NULL;
	WebKitDOMHTMLElement* _tmp72_ = NULL;
	gchar* _tmp73_ = NULL;
	GError * _inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_DOCUMENT (doc), NULL);
#line 52 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (exclude != NULL, NULL);
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = doc;
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = webkit_dom_document_get_body (_tmp0_);
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = util_dom_clone_node (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, webkit_dom_node_get_type (), WebKitDOMNode), TRUE);
#line 53 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	copy = _tmp2_;
#line 54 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = copy;
#line 54 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp3_ == NULL) {
#line 323 "util-webkit.c"
		gchar* _tmp4_ = NULL;
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = g_strdup ("");
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp4_;
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (copy);
#line 55 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 333 "util-webkit.c"
	}
#line 59 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	while (TRUE) {
#line 337 "util-webkit.c"
		WebKitDOMHTMLElement* current = NULL;
		WebKitDOMHTMLElement* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		WebKitDOMHTMLElement* _tmp7_ = NULL;
		WebKitDOMHTMLElement* _tmp8_ = NULL;
		WebKitDOMNode* parent = NULL;
		WebKitDOMHTMLElement* _tmp9_ = NULL;
		WebKitDOMNode* _tmp10_ = NULL;
		WebKitDOMNode* _tmp11_ = NULL;
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp5_ = copy;
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp6_ = exclude;
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = util_dom_select (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, webkit_dom_node_get_type (), WebKitDOMNode), _tmp6_);
#line 60 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		current = _tmp7_;
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = current;
#line 61 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (_tmp8_ == NULL) {
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (current);
#line 62 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			break;
#line 363 "util-webkit.c"
		}
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp9_ = current;
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = webkit_dom_node_get_parent_node (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 65 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		parent = _tmp11_;
#line 373 "util-webkit.c"
		{
			WebKitDOMNode* _tmp12_ = NULL;
			WebKitDOMHTMLElement* _tmp13_ = NULL;
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp12_ = parent;
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp13_ = current;
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			webkit_dom_node_remove_child (_tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, webkit_dom_node_get_type (), WebKitDOMNode), &_inner_error_);
#line 67 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 385 "util-webkit.c"
				goto __catch180_g_error;
			}
		}
		goto __finally180;
		__catch180_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_error_ = _inner_error_;
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_inner_error_ = NULL;
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp14_ = _error_;
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp15_ = _tmp14_->message;
#line 69 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_debug ("util-webkit.vala:69: Error removing blockquotes: %s", _tmp15_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_error_free0 (_error_);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (parent);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (current);
#line 70 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			break;
#line 413 "util-webkit.c"
		}
		__finally180:
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (parent);
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (current);
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (copy);
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 66 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return NULL;
#line 430 "util-webkit.c"
		}
#line 59 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (parent);
#line 59 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (current);
#line 436 "util-webkit.c"
	}
	{
		WebKitDOMNodeList* _tmp16_ = NULL;
		WebKitDOMHTMLElement* _tmp17_ = NULL;
		WebKitDOMNodeList* _tmp18_ = NULL;
		WebKitDOMNodeList* _tmp19_ = NULL;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp17_ = copy;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp18_ = webkit_dom_element_query_selector_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, webkit_dom_element_get_type (), WebKitDOMElement), "br", &_inner_error_);
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp16_ = _tmp18_;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 451 "util-webkit.c"
			goto __catch181_g_error;
		}
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp19_ = _tmp16_;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp16_ = NULL;
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 76 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		node_list = _tmp19_;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (_tmp16_);
#line 464 "util-webkit.c"
	}
	goto __finally181;
	__catch181_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		WebKitDOMHTMLElement* _tmp22_ = NULL;
		gchar* _tmp23_ = NULL;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 78 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp20_ = _error_;
#line 78 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp21_ = _tmp20_->message;
#line 78 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:78: Error finding <br>s: %s", _tmp21_);
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp22_ = copy;
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp23_ = webkit_dom_html_element_get_inner_text (_tmp22_);
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp23_;
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (copy);
#line 79 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 498 "util-webkit.c"
	}
	__finally181:
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (copy);
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 75 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 513 "util-webkit.c"
	}
	{
		gint i = 0;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		i = 0;
#line 519 "util-webkit.c"
		{
			gboolean _tmp24_ = FALSE;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp24_ = TRUE;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 526 "util-webkit.c"
				gint _tmp26_ = 0;
				WebKitDOMNodeList* _tmp27_ = NULL;
				gulong _tmp28_ = 0UL;
				gulong _tmp29_ = 0UL;
				WebKitDOMNode* br = NULL;
				WebKitDOMNodeList* _tmp30_ = NULL;
				gint _tmp31_ = 0;
				WebKitDOMNode* _tmp32_ = NULL;
				WebKitDOMNode* _tmp33_ = NULL;
				WebKitDOMNode* parent = NULL;
				WebKitDOMNode* _tmp34_ = NULL;
				WebKitDOMNode* _tmp35_ = NULL;
				WebKitDOMNode* _tmp36_ = NULL;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp24_) {
#line 542 "util-webkit.c"
					gint _tmp25_ = 0;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp25_ = i;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = _tmp25_ + 1;
#line 548 "util-webkit.c"
				}
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp24_ = FALSE;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp26_ = i;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp27_ = node_list;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp28_ = webkit_dom_node_list_get_length (_tmp27_);
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp29_ = _tmp28_;
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(((gulong) _tmp26_) < _tmp29_)) {
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 564 "util-webkit.c"
				}
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp30_ = node_list;
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp31_ = i;
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp32_ = webkit_dom_node_list_item (_tmp30_, (gulong) _tmp31_);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp33_ = _g_object_ref0 (_tmp32_);
#line 84 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				br = _tmp33_;
#line 85 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp34_ = br;
#line 85 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp35_ = webkit_dom_node_get_parent_node (_tmp34_);
#line 85 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp36_ = _g_object_ref0 (_tmp35_);
#line 85 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				parent = _tmp36_;
#line 584 "util-webkit.c"
				{
					WebKitDOMNode* _tmp37_ = NULL;
					WebKitDOMDocument* _tmp38_ = NULL;
					WebKitDOMText* _tmp39_ = NULL;
					WebKitDOMNode* _tmp40_ = NULL;
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp37_ = parent;
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp38_ = doc;
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp39_ = webkit_dom_document_create_text_node (_tmp38_, "\n");
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp40_ = br;
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_node_replace_child (_tmp37_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, webkit_dom_node_get_type (), WebKitDOMNode), _tmp40_, &_inner_error_);
#line 87 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 602 "util-webkit.c"
						goto __catch182_g_error;
					}
				}
				goto __finally182;
				__catch182_g_error:
				{
					GError* _error_ = NULL;
					GError* _tmp41_ = NULL;
					const gchar* _tmp42_ = NULL;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_error_ = _inner_error_;
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_inner_error_ = NULL;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp41_ = _error_;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp42_ = _tmp41_->message;
#line 89 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_debug ("util-webkit.vala:89: Error replacing <br>: %s", _tmp42_);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_error_free0 (_error_);
#line 624 "util-webkit.c"
				}
				__finally182:
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (parent);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (br);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (node_list);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (copy);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_clear_error (&_inner_error_);
#line 86 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					return NULL;
#line 643 "util-webkit.c"
				}
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (parent);
#line 83 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (br);
#line 649 "util-webkit.c"
			}
		}
	}
	{
		WebKitDOMNodeList* _tmp43_ = NULL;
		WebKitDOMHTMLElement* _tmp44_ = NULL;
		WebKitDOMNodeList* _tmp45_ = NULL;
		WebKitDOMNodeList* _tmp46_ = NULL;
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp44_ = copy;
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp45_ = webkit_dom_element_query_selector_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, webkit_dom_element_get_type (), WebKitDOMElement), "div", &_inner_error_);
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp43_ = _tmp45_;
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 666 "util-webkit.c"
			goto __catch183_g_error;
		}
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp46_ = _tmp43_;
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp43_ = NULL;
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 94 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		node_list = _tmp46_;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (_tmp43_);
#line 679 "util-webkit.c"
	}
	goto __finally183;
	__catch183_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp47_ = NULL;
		const gchar* _tmp48_ = NULL;
		WebKitDOMHTMLElement* _tmp49_ = NULL;
		gchar* _tmp50_ = NULL;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 96 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp47_ = _error_;
#line 96 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp48_ = _tmp47_->message;
#line 96 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:96: Error finding <div>s: %s", _tmp48_);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp49_ = copy;
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp50_ = webkit_dom_html_element_get_inner_text (_tmp49_);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp50_;
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (copy);
#line 97 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 713 "util-webkit.c"
	}
	__finally183:
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (copy);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 93 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 728 "util-webkit.c"
	}
	{
		gint i = 0;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		i = 0;
#line 734 "util-webkit.c"
		{
			gboolean _tmp51_ = FALSE;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp51_ = TRUE;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 741 "util-webkit.c"
				gint _tmp53_ = 0;
				WebKitDOMNodeList* _tmp54_ = NULL;
				gulong _tmp55_ = 0UL;
				gulong _tmp56_ = 0UL;
				WebKitDOMNode* div = NULL;
				WebKitDOMNodeList* _tmp57_ = NULL;
				gint _tmp58_ = 0;
				WebKitDOMNode* _tmp59_ = NULL;
				WebKitDOMNode* _tmp60_ = NULL;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp51_) {
#line 753 "util-webkit.c"
					gint _tmp52_ = 0;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp52_ = i;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = _tmp52_ + 1;
#line 759 "util-webkit.c"
				}
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp51_ = FALSE;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp53_ = i;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp54_ = node_list;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp55_ = webkit_dom_node_list_get_length (_tmp54_);
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp56_ = _tmp55_;
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(((gulong) _tmp53_) < _tmp56_)) {
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 775 "util-webkit.c"
				}
#line 102 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp57_ = node_list;
#line 102 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp58_ = i;
#line 102 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp59_ = webkit_dom_node_list_item (_tmp57_, (gulong) _tmp58_);
#line 102 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp60_ = _g_object_ref0 (_tmp59_);
#line 102 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				div = _tmp60_;
#line 787 "util-webkit.c"
				{
					WebKitDOMNode* _tmp61_ = NULL;
					WebKitDOMDocument* _tmp62_ = NULL;
					WebKitDOMText* _tmp63_ = NULL;
					WebKitDOMNode* _tmp64_ = NULL;
					WebKitDOMNode* _tmp65_ = NULL;
					WebKitDOMNode* _tmp66_ = NULL;
					WebKitDOMNode* _tmp67_ = NULL;
					WebKitDOMDocument* _tmp68_ = NULL;
					WebKitDOMText* _tmp69_ = NULL;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp61_ = div;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp62_ = doc;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp63_ = webkit_dom_document_create_text_node (_tmp62_, "\n");
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp64_ = div;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp65_ = webkit_dom_node_get_first_child (_tmp64_);
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp66_ = _tmp65_;
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_node_insert_before (_tmp61_, G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, webkit_dom_node_get_type (), WebKitDOMNode), _tmp66_, &_inner_error_);
#line 104 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 814 "util-webkit.c"
						goto __catch184_g_error;
					}
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp67_ = div;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp68_ = doc;
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp69_ = webkit_dom_document_create_text_node (_tmp68_, "\n");
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_node_append_child (_tmp67_, G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, webkit_dom_node_get_type (), WebKitDOMNode), &_inner_error_);
#line 105 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 827 "util-webkit.c"
						goto __catch184_g_error;
					}
				}
				goto __finally184;
				__catch184_g_error:
				{
					GError* _error_ = NULL;
					GError* _tmp70_ = NULL;
					const gchar* _tmp71_ = NULL;
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_error_ = _inner_error_;
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_inner_error_ = NULL;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp70_ = _error_;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp71_ = _tmp70_->message;
#line 107 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_debug ("util-webkit.vala:107: Error padding <div> with newlines: %s", _tmp71_);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_error_free0 (_error_);
#line 849 "util-webkit.c"
				}
				__finally184:
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (div);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (node_list);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (copy);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_clear_error (&_inner_error_);
#line 103 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					return NULL;
#line 866 "util-webkit.c"
				}
#line 101 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (div);
#line 870 "util-webkit.c"
			}
		}
	}
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp72_ = copy;
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp73_ = webkit_dom_html_element_get_inner_text (_tmp72_);
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp73_;
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (node_list);
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (copy);
#line 110 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 886 "util-webkit.c"
}


void bind_event (WebKitWebView* view, const gchar* selector, const gchar* event, GCallback callback, GObject* extra) {
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (WEBKIT_IS_WEB_VIEW (view));
#line 114 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (selector != NULL);
#line 114 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (event != NULL);
#line 114 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail ((extra == NULL) || G_IS_OBJECT (extra));
#line 900 "util-webkit.c"
	{
		WebKitDOMNodeList* node_list = NULL;
		WebKitWebView* _tmp0_ = NULL;
		WebKitDOMDocument* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		WebKitDOMNodeList* _tmp3_ = NULL;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp0_ = view;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = webkit_web_view_get_dom_document (_tmp0_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = selector;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = webkit_dom_document_query_selector_all (_tmp1_, _tmp2_, &_inner_error_);
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		node_list = _tmp3_;
#line 117 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 919 "util-webkit.c"
			goto __catch185_g_error;
		}
		{
			gint i = 0;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			i = 0;
#line 926 "util-webkit.c"
			{
				gboolean _tmp4_ = FALSE;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp4_ = TRUE;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				while (TRUE) {
#line 933 "util-webkit.c"
					gint _tmp6_ = 0;
					WebKitDOMNodeList* _tmp7_ = NULL;
					gulong _tmp8_ = 0UL;
					gulong _tmp9_ = 0UL;
					WebKitDOMEventTarget* node = NULL;
					WebKitDOMNodeList* _tmp10_ = NULL;
					gint _tmp11_ = 0;
					WebKitDOMNode* _tmp12_ = NULL;
					WebKitDOMEventTarget* _tmp13_ = NULL;
					WebKitDOMEventTarget* _tmp14_ = NULL;
					const gchar* _tmp15_ = NULL;
					GCallback _tmp16_ = NULL;
					WebKitDOMEventTarget* _tmp17_ = NULL;
					const gchar* _tmp18_ = NULL;
					GCallback _tmp19_ = NULL;
					GObject* _tmp20_ = NULL;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (!_tmp4_) {
#line 952 "util-webkit.c"
						gint _tmp5_ = 0;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp5_ = i;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						i = _tmp5_ + 1;
#line 958 "util-webkit.c"
					}
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp4_ = FALSE;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp6_ = i;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp7_ = node_list;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp8_ = webkit_dom_node_list_get_length (_tmp7_);
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp9_ = _tmp8_;
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (!(((gulong) _tmp6_) < _tmp9_)) {
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						break;
#line 974 "util-webkit.c"
					}
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp10_ = node_list;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp11_ = i;
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp12_ = webkit_dom_node_list_item (_tmp10_, (gulong) _tmp11_);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, webkit_dom_event_target_get_type()) ? ((WebKitDOMEventTarget*) _tmp12_) : NULL);
#line 119 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					node = _tmp13_;
#line 120 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp14_ = node;
#line 120 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp15_ = event;
#line 120 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp16_ = callback;
#line 120 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_event_target_remove_event_listener (_tmp14_, _tmp15_, _tmp16_, FALSE);
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp17_ = node;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp18_ = event;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp19_ = callback;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp20_ = extra;
#line 121 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_event_target_add_event_listener (_tmp17_, _tmp18_, _tmp19_, FALSE, _tmp20_);
#line 118 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (node);
#line 1006 "util-webkit.c"
				}
			}
		}
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (node_list);
#line 1012 "util-webkit.c"
	}
	goto __finally185;
	__catch185_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp21_ = _error_;
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp22_ = _tmp21_->message;
#line 124 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_warning ("util-webkit.vala:124: Error setting up click handlers: %s", _tmp22_);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 1032 "util-webkit.c"
	}
	__finally185:
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 116 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return;
#line 1043 "util-webkit.c"
	}
}


void linkify_document (WebKitDOMDocument* document) {
	WebKitDOMDocument* _tmp0_ = NULL;
	WebKitDOMDocument* _tmp1_ = NULL;
	WebKitDOMHTMLElement* _tmp2_ = NULL;
#line 129 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (WEBKIT_DOM_IS_DOCUMENT (document));
#line 130 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = document;
#line 130 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = document;
#line 130 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = webkit_dom_document_get_body (_tmp1_);
#line 130 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	linkify_recurse (_tmp0_, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, webkit_dom_node_get_type (), WebKitDOMNode), FALSE);
#line 1062 "util-webkit.c"
}


gboolean pre_split_urls (GMatchInfo* match_info, GString* _result_) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 138 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (match_info != NULL, FALSE);
#line 138 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 1073 "util-webkit.c"
	{
		gchar* url = NULL;
		GMatchInfo* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		GRegex* r = NULL;
		GRegex* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		GString* _tmp7_ = NULL;
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp0_ = match_info;
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = g_match_info_fetch (_tmp0_, 0);
#line 140 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		url = _tmp1_;
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = g_regex_new (PROTOCOL_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		r = _tmp2_;
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 141 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (url);
#line 1097 "util-webkit.c"
			goto __catch186_g_error;
		}
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = g_regex_match (r, url, 0, NULL);
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (_tmp4_) {
#line 1104 "util-webkit.c"
			gchar* _tmp5_ = NULL;
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp5_ = g_strdup_printf ("\01%s\01", url);
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (_tmp3_);
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = _tmp5_;
#line 1112 "util-webkit.c"
		} else {
			gchar* _tmp6_ = NULL;
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp6_ = g_strdup (url);
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (_tmp3_);
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = _tmp6_;
#line 1121 "util-webkit.c"
		}
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = _result_;
#line 142 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_string_append (_tmp7_, _tmp3_);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp3_);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_regex_unref0 (r);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (url);
#line 1133 "util-webkit.c"
	}
	goto __finally186;
	__catch186_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		e = _inner_error_;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 144 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = e;
#line 144 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp9_ = _tmp8_->message;
#line 144 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:144: URL parsing error: %s\n", _tmp9_);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (e);
#line 1153 "util-webkit.c"
	}
	__finally186:
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1158 "util-webkit.c"
		gboolean _tmp10_ = FALSE;
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 139 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return _tmp10_;
#line 1166 "util-webkit.c"
	}
#line 146 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = FALSE;
#line 146 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 1172 "util-webkit.c"
}


static gboolean _pre_split_urls_gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self) {
	gboolean result;
	result = pre_split_urls (match_info, _result_);
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 1181 "util-webkit.c"
}


void linkify_recurse (WebKitDOMDocument* document, WebKitDOMNode* node, gboolean _in_link) {
	gboolean in_link = FALSE;
	gboolean _tmp0_ = FALSE;
	WebKitDOMNode* _tmp1_ = NULL;
	gchar* input = NULL;
	WebKitDOMNode* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	WebKitDOMNodeList* list = NULL;
	WebKitDOMNode* _tmp74_ = NULL;
	WebKitDOMNodeList* _tmp75_ = NULL;
	GError * _inner_error_ = NULL;
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (WEBKIT_DOM_IS_DOCUMENT (document));
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_if_fail (WEBKIT_DOM_IS_NODE (node));
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = _in_link;
#line 155 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	in_link = _tmp0_;
#line 156 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = node;
#line 156 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, webkit_dom_html_anchor_element_get_type ())) {
#line 157 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		in_link = TRUE;
#line 1212 "util-webkit.c"
	}
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = node;
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = webkit_dom_node_get_node_value (_tmp2_);
#line 159 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	input = _tmp3_;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = in_link;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (!_tmp5_) {
#line 1224 "util-webkit.c"
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp6_ = input;
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = geary_string_is_empty (_tmp6_);
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = !_tmp7_;
#line 1233 "util-webkit.c"
	} else {
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = FALSE;
#line 1237 "util-webkit.c"
	}
#line 160 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp4_) {
#line 1241 "util-webkit.c"
		{
			GRegex* r = NULL;
			GRegex* _tmp8_ = NULL;
			gchar* output = NULL;
			GRegex* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
			const gchar* _tmp13_ = NULL;
#line 162 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp8_ = g_regex_new (URL_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 162 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			r = _tmp8_;
#line 162 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1257 "util-webkit.c"
				goto __catch187_g_error;
			}
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp9_ = r;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp10_ = input;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp11_ = g_regex_replace_eval (_tmp9_, _tmp10_, (gssize) -1, 0, 0, _pre_split_urls_gregex_eval_callback, NULL, &_inner_error_);
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			output = _tmp11_;
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 163 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_regex_unref0 (r);
#line 1272 "util-webkit.c"
				goto __catch187_g_error;
			}
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp12_ = input;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp13_ = output;
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (g_strcmp0 (_tmp12_, _tmp13_) != 0) {
#line 1281 "util-webkit.c"
				GRegex* tester = NULL;
				GRegex* _tmp14_ = NULL;
				gchar** pieces = NULL;
				const gchar* _tmp15_ = NULL;
				gchar** _tmp16_ = NULL;
				gchar** _tmp17_ = NULL;
				gint pieces_length1 = 0;
				gint _pieces_size_ = 0;
				GeeArrayList* new_nodes = NULL;
				GeeArrayList* _tmp18_ = NULL;
				WebKitDOMNode* sibling = NULL;
				WebKitDOMNode* _tmp51_ = NULL;
				WebKitDOMNode* _tmp52_ = NULL;
				WebKitDOMNode* _tmp53_ = NULL;
				WebKitDOMNode* _tmp71_ = NULL;
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp14_ = g_regex_new (PROTOCOL_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				tester = _tmp14_;
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (output);
#line 166 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_regex_unref0 (r);
#line 1307 "util-webkit.c"
					goto __catch187_g_error;
				}
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp15_ = output;
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "\01", 0);
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				pieces = _tmp17_;
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				pieces_length1 = _vala_array_length (_tmp16_);
#line 167 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_pieces_size_ = pieces_length1;
#line 168 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp18_ = gee_array_list_new (webkit_dom_node_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 168 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				new_nodes = _tmp18_;
#line 1324 "util-webkit.c"
				{
					gint i = 0;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = 0;
#line 1329 "util-webkit.c"
					{
						gboolean _tmp19_ = FALSE;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp19_ = TRUE;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						while (TRUE) {
#line 1336 "util-webkit.c"
							gint _tmp21_ = 0;
							gchar** _tmp22_ = NULL;
							gint _tmp22__length1 = 0;
							GRegex* _tmp23_ = NULL;
							gchar** _tmp24_ = NULL;
							gint _tmp24__length1 = 0;
							gint _tmp25_ = 0;
							const gchar* _tmp26_ = NULL;
							gboolean _tmp27_ = FALSE;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (!_tmp19_) {
#line 1348 "util-webkit.c"
								gint _tmp20_ = 0;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp20_ = i;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								i = _tmp20_ + 1;
#line 1354 "util-webkit.c"
							}
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp19_ = FALSE;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp21_ = i;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp22_ = pieces;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp22__length1 = pieces_length1;
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (!(_tmp21_ < _tmp22__length1)) {
#line 170 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								break;
#line 1368 "util-webkit.c"
							}
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp23_ = tester;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp24_ = pieces;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp24__length1 = pieces_length1;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp25_ = i;
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp26_ = _tmp24_[_tmp25_];
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp27_ = g_regex_match (_tmp23_, _tmp26_, 0, NULL);
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (_tmp27_) {
#line 1384 "util-webkit.c"
								WebKitDOMElement* _tmp28_ = NULL;
								WebKitDOMDocument* _tmp29_ = NULL;
								WebKitDOMElement* _tmp30_ = NULL;
								WebKitDOMHTMLAnchorElement* anchor = NULL;
								WebKitDOMHTMLAnchorElement* _tmp31_ = NULL;
								WebKitDOMHTMLAnchorElement* _tmp32_ = NULL;
								gchar** _tmp33_ = NULL;
								gint _tmp33__length1 = 0;
								gint _tmp34_ = 0;
								const gchar* _tmp35_ = NULL;
								WebKitDOMHTMLAnchorElement* _tmp36_ = NULL;
								gchar** _tmp37_ = NULL;
								gint _tmp37__length1 = 0;
								gint _tmp38_ = 0;
								const gchar* _tmp39_ = NULL;
								GeeArrayList* _tmp40_ = NULL;
								WebKitDOMHTMLAnchorElement* _tmp41_ = NULL;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp29_ = document;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp30_ = webkit_dom_document_create_element (_tmp29_, "a", &_inner_error_);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp28_ = _tmp30_;
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_nodes);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (tester);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_free0 (output);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (r);
#line 1420 "util-webkit.c"
									goto __catch187_g_error;
								}
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp31_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, webkit_dom_html_anchor_element_get_type ()) ? ((WebKitDOMHTMLAnchorElement*) _tmp28_) : NULL);
#line 174 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								anchor = _tmp31_;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp32_ = anchor;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp33_ = pieces;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp33__length1 = pieces_length1;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp34_ = i;
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp35_ = _tmp33_[_tmp34_];
#line 176 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								webkit_dom_html_anchor_element_set_href (_tmp32_, _tmp35_);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp36_ = anchor;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp37_ = pieces;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp37__length1 = pieces_length1;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp38_ = i;
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp39_ = _tmp37_[_tmp38_];
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								webkit_dom_html_element_set_inner_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, webkit_dom_html_element_get_type (), WebKitDOMHTMLElement), _tmp39_, &_inner_error_);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (anchor);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_nodes);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (tester);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_free0 (output);
#line 177 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (r);
#line 1465 "util-webkit.c"
									goto __catch187_g_error;
								}
#line 178 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp40_ = new_nodes;
#line 178 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp41_ = anchor;
#line 178 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_g_object_unref0 (anchor);
#line 1476 "util-webkit.c"
							} else {
								WebKitDOMNode* new_node = NULL;
								WebKitDOMNode* _tmp42_ = NULL;
								WebKitDOMNode* _tmp43_ = NULL;
								WebKitDOMNode* _tmp44_ = NULL;
								WebKitDOMNode* _tmp45_ = NULL;
								gchar** _tmp46_ = NULL;
								gint _tmp46__length1 = 0;
								gint _tmp47_ = 0;
								const gchar* _tmp48_ = NULL;
								GeeArrayList* _tmp49_ = NULL;
								WebKitDOMNode* _tmp50_ = NULL;
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp42_ = node;
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp43_ = webkit_dom_node_clone_node (_tmp42_, FALSE);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp44_ = _g_object_ref0 (_tmp43_);
#line 181 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								new_node = _tmp44_;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp45_ = new_node;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp46_ = pieces;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp46__length1 = pieces_length1;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp47_ = i;
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp48_ = _tmp46_[_tmp47_];
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								webkit_dom_node_set_node_value (_tmp45_, _tmp48_, &_inner_error_);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_node);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_nodes);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (tester);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_free0 (output);
#line 182 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (r);
#line 1523 "util-webkit.c"
									goto __catch187_g_error;
								}
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp49_ = new_nodes;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp50_ = new_node;
#line 183 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp50_);
#line 172 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_g_object_unref0 (new_node);
#line 1534 "util-webkit.c"
							}
						}
					}
				}
#line 188 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp51_ = node;
#line 188 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp52_ = webkit_dom_node_get_next_sibling (_tmp51_);
#line 188 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp53_ = _g_object_ref0 (_tmp52_);
#line 188 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				sibling = _tmp53_;
#line 1547 "util-webkit.c"
				{
					gint i = 0;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = 0;
#line 1552 "util-webkit.c"
					{
						gboolean _tmp54_ = FALSE;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp54_ = TRUE;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						while (TRUE) {
#line 1559 "util-webkit.c"
							gint _tmp56_ = 0;
							GeeArrayList* _tmp57_ = NULL;
							gint _tmp58_ = 0;
							gint _tmp59_ = 0;
							WebKitDOMNode* new_node = NULL;
							GeeArrayList* _tmp60_ = NULL;
							gint _tmp61_ = 0;
							gpointer _tmp62_ = NULL;
							WebKitDOMNode* _tmp63_ = NULL;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (!_tmp54_) {
#line 1571 "util-webkit.c"
								gint _tmp55_ = 0;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp55_ = i;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								i = _tmp55_ + 1;
#line 1577 "util-webkit.c"
							}
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp54_ = FALSE;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp56_ = i;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp57_ = new_nodes;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp58_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection));
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp59_ = _tmp58_;
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (!(_tmp56_ < _tmp59_)) {
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								break;
#line 1593 "util-webkit.c"
							}
#line 190 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp60_ = new_nodes;
#line 190 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp61_ = i;
#line 190 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp62_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp61_);
#line 190 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							new_node = (WebKitDOMNode*) _tmp62_;
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp63_ = sibling;
#line 191 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (_tmp63_ == NULL) {
#line 1607 "util-webkit.c"
								WebKitDOMNode* _tmp64_ = NULL;
								WebKitDOMNode* _tmp65_ = NULL;
								WebKitDOMNode* _tmp66_ = NULL;
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp64_ = node;
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp65_ = webkit_dom_node_get_parent_node (_tmp64_);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp66_ = new_node;
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								webkit_dom_node_append_child (_tmp65_, _tmp66_, &_inner_error_);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_node);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (sibling);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_nodes);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (tester);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_free0 (output);
#line 192 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (r);
#line 1635 "util-webkit.c"
									goto __catch187_g_error;
								}
							} else {
								WebKitDOMNode* _tmp67_ = NULL;
								WebKitDOMNode* _tmp68_ = NULL;
								WebKitDOMNode* _tmp69_ = NULL;
								WebKitDOMNode* _tmp70_ = NULL;
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp67_ = node;
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp68_ = webkit_dom_node_get_parent_node (_tmp67_);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp69_ = new_node;
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp70_ = sibling;
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								webkit_dom_node_insert_before (_tmp68_, _tmp69_, _tmp70_, &_inner_error_);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_node);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (sibling);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_object_unref0 (new_nodes);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (tester);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_free0 (output);
#line 194 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_g_regex_unref0 (r);
#line 1669 "util-webkit.c"
									goto __catch187_g_error;
								}
							}
#line 189 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_g_object_unref0 (new_node);
#line 1675 "util-webkit.c"
						}
					}
				}
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp71_ = node;
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				webkit_dom_node_set_node_value (_tmp71_, "", &_inner_error_);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (sibling);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (new_nodes);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_regex_unref0 (tester);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (output);
#line 198 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_regex_unref0 (r);
#line 1697 "util-webkit.c"
					goto __catch187_g_error;
				}
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (sibling);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (new_nodes);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				pieces = (_vala_array_free (pieces, pieces_length1, (GDestroyNotify) g_free), NULL);
#line 164 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_regex_unref0 (tester);
#line 1708 "util-webkit.c"
			}
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (output);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_regex_unref0 (r);
#line 1714 "util-webkit.c"
		}
		goto __finally187;
		__catch187_g_error:
		{
			GError* e = NULL;
			GError* _tmp72_ = NULL;
			const gchar* _tmp73_ = NULL;
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			e = _inner_error_;
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_inner_error_ = NULL;
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp72_ = e;
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp73_ = _tmp72_->message;
#line 201 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_debug ("util-webkit.vala:201: Error linkifying outgoing mail: %s", _tmp73_);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_error_free0 (e);
#line 1734 "util-webkit.c"
		}
		__finally187:
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (input);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			g_clear_error (&_inner_error_);
#line 161 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			return;
#line 1747 "util-webkit.c"
		}
	}
#line 206 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp74_ = node;
#line 206 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp75_ = webkit_dom_node_get_child_nodes (_tmp74_);
#line 206 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	list = _tmp75_;
#line 1756 "util-webkit.c"
	{
		gint i = 0;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		i = 0;
#line 1761 "util-webkit.c"
		{
			gboolean _tmp76_ = FALSE;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp76_ = TRUE;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 1768 "util-webkit.c"
				gint _tmp78_ = 0;
				WebKitDOMNodeList* _tmp79_ = NULL;
				gulong _tmp80_ = 0UL;
				gulong _tmp81_ = 0UL;
				WebKitDOMDocument* _tmp82_ = NULL;
				WebKitDOMNodeList* _tmp83_ = NULL;
				gint _tmp84_ = 0;
				WebKitDOMNode* _tmp85_ = NULL;
				gboolean _tmp86_ = FALSE;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp76_) {
#line 1780 "util-webkit.c"
					gint _tmp77_ = 0;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp77_ = i;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = _tmp77_ + 1;
#line 1786 "util-webkit.c"
				}
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp76_ = FALSE;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp78_ = i;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp79_ = list;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp80_ = webkit_dom_node_list_get_length (_tmp79_);
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp81_ = _tmp80_;
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(((gulong) _tmp78_) < _tmp81_)) {
#line 207 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 1802 "util-webkit.c"
				}
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp82_ = document;
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp83_ = list;
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp84_ = i;
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp85_ = webkit_dom_node_list_item (_tmp83_, (gulong) _tmp84_);
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp86_ = in_link;
#line 208 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				linkify_recurse (_tmp82_, _tmp85_, _tmp86_);
#line 1816 "util-webkit.c"
			}
		}
	}
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (list);
#line 152 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (input);
#line 1824 "util-webkit.c"
}


gboolean is_valid_url (GMatchInfo* match_info, GString* _result_) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 215 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (match_info != NULL, FALSE);
#line 215 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (_result_ != NULL, FALSE);
#line 1835 "util-webkit.c"
	{
		gchar* url = NULL;
		GMatchInfo* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		GRegex* r = NULL;
		GRegex* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		GString* _tmp7_ = NULL;
#line 217 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp0_ = match_info;
#line 217 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = g_match_info_fetch (_tmp0_, 0);
#line 217 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		url = _tmp1_;
#line 218 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = g_regex_new (PROTOCOL_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 218 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		r = _tmp2_;
#line 218 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 218 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (url);
#line 1859 "util-webkit.c"
			goto __catch188_g_error;
		}
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = g_regex_match (r, url, 0, NULL);
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (_tmp4_) {
#line 1866 "util-webkit.c"
			gchar* _tmp5_ = NULL;
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp5_ = g_strdup_printf ("<a href=\"%s\">%s</a>", url, url);
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (_tmp3_);
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = _tmp5_;
#line 1874 "util-webkit.c"
		} else {
			gchar* _tmp6_ = NULL;
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp6_ = g_strdup (url);
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (_tmp3_);
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = _tmp6_;
#line 1883 "util-webkit.c"
		}
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = _result_;
#line 220 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_string_append (_tmp7_, _tmp3_);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp3_);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_regex_unref0 (r);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (url);
#line 1895 "util-webkit.c"
	}
	goto __finally188;
	__catch188_g_error:
	{
		GError* e = NULL;
		GError* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		e = _inner_error_;
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 222 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = e;
#line 222 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp9_ = _tmp8_->message;
#line 222 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:222: URL parsing error: %s\n", _tmp9_);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (e);
#line 1915 "util-webkit.c"
	}
	__finally188:
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1920 "util-webkit.c"
		gboolean _tmp10_ = FALSE;
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 216 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return _tmp10_;
#line 1928 "util-webkit.c"
	}
#line 224 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = FALSE;
#line 224 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 1934 "util-webkit.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1388 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1388 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1388 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1947 "util-webkit.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 1978 "util-webkit.c"
				goto __catch189_g_regex_error;
			}
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1390 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			return NULL;
#line 1987 "util-webkit.c"
		}
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) -1, 0, _tmp7_, 0, &_inner_error_);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 2003 "util-webkit.c"
				goto __catch189_g_regex_error;
			}
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			return NULL;
#line 2014 "util-webkit.c"
		}
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = _tmp5_;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = NULL;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp9_;
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_free0 (_tmp5_);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1391 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 2028 "util-webkit.c"
	}
	goto __finally189;
	__catch189_g_regex_error:
	{
		GError* e = NULL;
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1393 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 2042 "util-webkit.c"
	}
	__finally189:
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1389 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return NULL;
#line 2053 "util-webkit.c"
	}
}


static gboolean _is_valid_url_gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self) {
	gboolean result;
	result = is_valid_url (match_info, _result_);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 2063 "util-webkit.c"
}


gchar* linkify_and_escape_plain_text (const gchar* input, GError** error) {
	gchar* result = NULL;
	gchar* output = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GRegex* r = NULL;
	GRegex* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	GRegex* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	GError * _inner_error_ = NULL;
#line 228 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = input;
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = string_replace (_tmp0_, "<", " \01 ");
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp1_;
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = string_replace (_tmp2_, ">", " \02 ");
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = _tmp3_;
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = string_replace (_tmp4_, "&", "&amp;");
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp6_ = _tmp5_;
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp4_);
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp2_);
#line 230 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	output = _tmp6_;
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp7_ = g_regex_new (URL_REGEX, G_REGEX_CASELESS, 0, &_inner_error_);
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	r = _tmp7_;
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_propagate_error (error, _inner_error_);
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (output);
#line 233 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 2124 "util-webkit.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp9_ = r;
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp10_ = output;
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp11_ = g_regex_replace_eval (_tmp9_, _tmp10_, (gssize) -1, 0, 0, _is_valid_url_gregex_eval_callback, NULL, &_inner_error_);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp8_ = _tmp11_;
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_propagate_error (error, _inner_error_);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_regex_unref0 (r);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (output);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 2144 "util-webkit.c"
	}
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp12_ = _tmp8_;
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp8_ = NULL;
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (output);
#line 235 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	output = _tmp12_;
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp13_ = output;
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp14_ = string_replace (_tmp13_, " \01 ", "&lt;");
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp15_ = _tmp14_;
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp16_ = string_replace (_tmp15_, " \02 ", "&gt;");
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp17_ = _tmp16_;
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp15_);
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp17_;
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp8_);
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_regex_unref0 (r);
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (output);
#line 236 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 2176 "util-webkit.c"
}


gboolean node_is_child_of (WebKitDOMNode* node, const gchar* ancestor_tag) {
	gboolean result = FALSE;
	WebKitDOMElement* ancestor = NULL;
	WebKitDOMNode* _tmp0_ = NULL;
	WebKitDOMElement* _tmp1_ = NULL;
	WebKitDOMElement* _tmp2_ = NULL;
#line 239 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_NODE (node), FALSE);
#line 239 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (ancestor_tag != NULL, FALSE);
#line 240 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = node;
#line 240 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = webkit_dom_node_get_parent_element (_tmp0_);
#line 240 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 240 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	ancestor = _tmp2_;
#line 2198 "util-webkit.c"
	{
		gboolean _tmp3_ = FALSE;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = TRUE;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		while (TRUE) {
#line 2205 "util-webkit.c"
			WebKitDOMElement* _tmp7_ = NULL;
			WebKitDOMElement* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			const gchar* _tmp11_ = NULL;
			gboolean _tmp12_ = FALSE;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (!_tmp3_) {
#line 2214 "util-webkit.c"
				WebKitDOMElement* _tmp4_ = NULL;
				WebKitDOMElement* _tmp5_ = NULL;
				WebKitDOMElement* _tmp6_ = NULL;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp4_ = ancestor;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp5_ = webkit_dom_node_get_parent_element (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp6_ = _g_object_ref0 (_tmp5_);
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (ancestor);
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				ancestor = _tmp6_;
#line 2228 "util-webkit.c"
			}
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = FALSE;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp7_ = ancestor;
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (!(_tmp7_ != NULL)) {
#line 241 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				break;
#line 2238 "util-webkit.c"
			}
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp8_ = ancestor;
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp9_ = webkit_dom_element_get_tag_name (_tmp8_);
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp10_ = _tmp9_;
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp11_ = ancestor_tag;
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp12_ = g_strcmp0 (_tmp10_, _tmp11_) == 0;
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_free0 (_tmp10_);
#line 242 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (_tmp12_) {
#line 243 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				result = TRUE;
#line 243 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (ancestor);
#line 243 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				return result;
#line 2260 "util-webkit.c"
			}
		}
	}
#line 246 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = FALSE;
#line 246 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (ancestor);
#line 246 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 2270 "util-webkit.c"
}


WebKitDOMHTMLElement* closest_ancestor (WebKitDOMElement* element, const gchar* selector) {
	WebKitDOMHTMLElement* result = NULL;
	GError * _inner_error_ = NULL;
#line 249 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_ELEMENT (element), NULL);
#line 249 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (selector != NULL, NULL);
#line 2281 "util-webkit.c"
	{
		WebKitDOMElement* parent = NULL;
		WebKitDOMElement* _tmp0_ = NULL;
		WebKitDOMElement* _tmp1_ = NULL;
		WebKitDOMElement* _tmp2_ = NULL;
		WebKitDOMElement* _tmp12_ = NULL;
		WebKitDOMHTMLElement* _tmp13_ = NULL;
#line 251 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp0_ = element;
#line 251 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = webkit_dom_node_get_parent_element (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 251 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 251 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		parent = _tmp2_;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		while (TRUE) {
#line 2299 "util-webkit.c"
			gboolean _tmp3_ = FALSE;
			WebKitDOMElement* _tmp4_ = NULL;
			WebKitDOMElement* _tmp9_ = NULL;
			WebKitDOMElement* _tmp10_ = NULL;
			WebKitDOMElement* _tmp11_ = NULL;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp4_ = parent;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (_tmp4_ != NULL) {
#line 2309 "util-webkit.c"
				gboolean _tmp5_ = FALSE;
				WebKitDOMElement* _tmp6_ = NULL;
				const gchar* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp6_ = parent;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp7_ = selector;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp8_ = webkit_dom_element_webkit_matches_selector (_tmp6_, _tmp7_, &_inner_error_);
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp5_ = _tmp8_;
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (parent);
#line 2326 "util-webkit.c"
					goto __catch190_g_error;
				}
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp3_ = !_tmp5_;
#line 2331 "util-webkit.c"
			} else {
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp3_ = FALSE;
#line 2335 "util-webkit.c"
			}
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (!_tmp3_) {
#line 252 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				break;
#line 2341 "util-webkit.c"
			}
#line 253 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp9_ = parent;
#line 253 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp10_ = webkit_dom_node_get_parent_element (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 253 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 253 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (parent);
#line 253 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			parent = _tmp11_;
#line 2353 "util-webkit.c"
		}
#line 255 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp12_ = parent;
#line 255 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, webkit_dom_html_element_get_type ()) ? ((WebKitDOMHTMLElement*) _tmp12_) : NULL);
#line 255 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp13_;
#line 255 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (parent);
#line 255 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 2365 "util-webkit.c"
	}
	goto __finally190;
	__catch190_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp14_ = NULL;
		const gchar* _tmp15_ = NULL;
#line 250 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 250 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 257 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp14_ = _error_;
#line 257 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp15_ = _tmp14_->message;
#line 257 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_warning ("util-webkit.vala:257: Failed to find ancestor: %s", _tmp15_);
#line 258 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = NULL;
#line 258 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 258 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 2389 "util-webkit.c"
	}
	__finally190:
#line 250 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 250 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_clear_error (&_inner_error_);
#line 250 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return NULL;
#line 2398 "util-webkit.c"
}


gboolean is_descendant_of (WebKitDOMElement* element, const gchar* selector) {
	gboolean result = FALSE;
	GError * _inner_error_ = NULL;
#line 262 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail ((element == NULL) || WEBKIT_DOM_IS_ELEMENT (element), FALSE);
#line 262 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (selector != NULL, FALSE);
#line 2409 "util-webkit.c"
	{
#line 264 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		while (TRUE) {
#line 2413 "util-webkit.c"
			WebKitDOMElement* _tmp0_ = NULL;
			gboolean _tmp1_ = FALSE;
			WebKitDOMElement* _tmp2_ = NULL;
			const gchar* _tmp3_ = NULL;
			gboolean _tmp4_ = FALSE;
			WebKitDOMElement* _tmp5_ = NULL;
			WebKitDOMElement* _tmp6_ = NULL;
#line 264 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp0_ = element;
#line 264 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (!(_tmp0_ != NULL)) {
#line 264 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				break;
#line 2427 "util-webkit.c"
			}
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp2_ = element;
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = selector;
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp4_ = webkit_dom_element_webkit_matches_selector (_tmp2_, _tmp3_, &_inner_error_);
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp1_ = _tmp4_;
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2439 "util-webkit.c"
				goto __catch191_g_error;
			}
#line 265 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			if (_tmp1_) {
#line 266 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				result = TRUE;
#line 266 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				return result;
#line 2448 "util-webkit.c"
			}
#line 267 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp5_ = element;
#line 267 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp6_ = webkit_dom_node_get_parent_element (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, webkit_dom_node_get_type (), WebKitDOMNode));
#line 267 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			element = _tmp6_;
#line 2456 "util-webkit.c"
		}
	}
	goto __finally191;
	__catch191_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 270 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = _error_;
#line 270 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = _tmp7_->message;
#line 270 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_warning ("util-webkit.vala:270: Problem traversing DOM: %s", _tmp8_);
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 2477 "util-webkit.c"
	}
	__finally191:
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 2482 "util-webkit.c"
		gboolean _tmp9_ = FALSE;
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 263 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return _tmp9_;
#line 2490 "util-webkit.c"
	}
#line 272 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = FALSE;
#line 272 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 2496 "util-webkit.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1303 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1304 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 2519 "util-webkit.c"
		glong _tmp4_ = 0L;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1305 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 2527 "util-webkit.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1307 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 2539 "util-webkit.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	glong _tmp8_ = 0L;
	glong _tmp14_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	gchar* _tmp22_ = NULL;
#line 1314 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 2563 "util-webkit.c"
		glong _tmp2_ = 0L;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 2569 "util-webkit.c"
	} else {
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2573 "util-webkit.c"
	}
#line 1316 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_) {
#line 2577 "util-webkit.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = offset;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = len;
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
#line 1318 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = _tmp5_;
#line 2589 "util-webkit.c"
	} else {
		gint _tmp6_ = 0;
		gint _tmp7_ = 0;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = strlen (self);
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = _tmp6_;
#line 1320 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp7_;
#line 2599 "util-webkit.c"
	}
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp8_ = offset;
#line 1323 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp8_ < ((glong) 0)) {
#line 2605 "util-webkit.c"
		glong _tmp9_ = 0L;
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp9_ = string_length;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = offset;
#line 1324 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		offset = _tmp9_ + _tmp10_;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1325 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
#line 2619 "util-webkit.c"
	} else {
		glong _tmp12_ = 0L;
		glong _tmp13_ = 0L;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp13_ = string_length;
#line 1327 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
#line 2629 "util-webkit.c"
	}
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp14_ = len;
#line 1329 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp14_ < ((glong) 0)) {
#line 2635 "util-webkit.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp16_ = offset;
#line 1330 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp15_ - _tmp16_;
#line 2644 "util-webkit.c"
	}
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = offset;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = len;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = string_length;
#line 1332 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = offset;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = len;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp22_;
#line 1333 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 2664 "util-webkit.c"
}


gchar* decorate_quotes (const gchar* text, GError** error) {
	gchar* result = NULL;
	gint level = 0;
	gchar* outtext = NULL;
	gchar* _tmp0_ = NULL;
	GRegex* quote_leader = NULL;
	GRegex* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar** _tmp3_ = NULL;
	gchar** _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
#line 275 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 276 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	level = 0;
#line 277 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = g_strdup ("");
#line 277 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	outtext = _tmp0_;
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = g_regex_new ("^(&gt;)* ?", 0, 0, &_inner_error_);
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	quote_leader = _tmp1_;
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_propagate_error (error, _inner_error_);
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (outtext);
#line 278 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 2699 "util-webkit.c"
	}
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = text;
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 2705 "util-webkit.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		line_collection = _tmp4_;
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp3_); line_it = line_it + 1) {
#line 2717 "util-webkit.c"
			gchar* _tmp5_ = NULL;
			gchar* line = NULL;
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			line = _tmp5_;
#line 2724 "util-webkit.c"
			{
				GMatchInfo* match_info = NULL;
				const gchar* _tmp6_ = NULL;
				GMatchInfo* _tmp7_ = NULL;
				gboolean _tmp8_ = FALSE;
#line 282 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp6_ = line;
#line 282 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp8_ = g_regex_match_all (quote_leader, _tmp6_, 0, &_tmp7_);
#line 282 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_match_info_unref0 (match_info);
#line 282 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				match_info = _tmp7_;
#line 282 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (_tmp8_) {
#line 2740 "util-webkit.c"
					gint start = 0;
					gint end = 0;
					gint new_level = 0;
					GMatchInfo* _tmp9_ = NULL;
					gint _tmp10_ = 0;
					gint _tmp11_ = 0;
					gint _tmp12_ = 0;
					const gchar* _tmp23_ = NULL;
					const gchar* _tmp24_ = NULL;
					gint _tmp25_ = 0;
					gchar* _tmp26_ = NULL;
					gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
#line 284 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp9_ = match_info;
#line 284 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_match_info_fetch_pos (_tmp9_, 0, &_tmp10_, &_tmp11_);
#line 284 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					start = _tmp10_;
#line 284 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					end = _tmp11_;
#line 285 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp12_ = end;
#line 285 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					new_level = _tmp12_ / 4;
#line 286 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					while (TRUE) {
#line 2768 "util-webkit.c"
						gint _tmp13_ = 0;
						gint _tmp14_ = 0;
						const gchar* _tmp15_ = NULL;
						gchar* _tmp16_ = NULL;
						gint _tmp17_ = 0;
#line 286 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp13_ = new_level;
#line 286 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp14_ = level;
#line 286 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (!(_tmp13_ > _tmp14_)) {
#line 286 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							break;
#line 2782 "util-webkit.c"
						}
#line 287 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp15_ = outtext;
#line 287 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp16_ = g_strconcat (_tmp15_, "<blockquote>", NULL);
#line 287 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (outtext);
#line 287 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						outtext = _tmp16_;
#line 288 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp17_ = level;
#line 288 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						level = _tmp17_ + 1;
#line 2796 "util-webkit.c"
					}
#line 290 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					while (TRUE) {
#line 2800 "util-webkit.c"
						gint _tmp18_ = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						gchar* _tmp21_ = NULL;
						gint _tmp22_ = 0;
#line 290 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp18_ = new_level;
#line 290 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp19_ = level;
#line 290 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (!(_tmp18_ < _tmp19_)) {
#line 290 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							break;
#line 2814 "util-webkit.c"
						}
#line 291 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp20_ = outtext;
#line 291 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp21_ = g_strconcat (_tmp20_, "</blockquote>", NULL);
#line 291 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (outtext);
#line 291 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						outtext = _tmp21_;
#line 292 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp22_ = level;
#line 292 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						level = _tmp22_ - 1;
#line 2828 "util-webkit.c"
					}
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp23_ = outtext;
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp24_ = line;
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp25_ = end;
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp26_ = string_substring (_tmp24_, (glong) _tmp25_, (glong) -1);
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp27_ = _tmp26_;
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp28_ = g_strconcat (_tmp23_, _tmp27_, NULL);
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (outtext);
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					outtext = _tmp28_;
#line 294 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp27_);
#line 2848 "util-webkit.c"
				} else {
					const gchar* _tmp29_ = NULL;
					const gchar* _tmp30_ = NULL;
					const gchar* _tmp31_ = NULL;
					gchar* _tmp32_ = NULL;
#line 296 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp29_ = line;
#line 296 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_debug ("util-webkit.vala:296: This line didn't match the quote regex: %s", _tmp29_);
#line 297 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp30_ = outtext;
#line 297 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp31_ = line;
#line 297 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp32_ = g_strconcat (_tmp30_, _tmp31_, NULL);
#line 297 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (outtext);
#line 297 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					outtext = _tmp32_;
#line 2868 "util-webkit.c"
				}
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_match_info_unref0 (match_info);
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (line);
#line 2874 "util-webkit.c"
			}
		}
#line 280 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2879 "util-webkit.c"
	}
#line 301 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	while (TRUE) {
#line 2883 "util-webkit.c"
		gint _tmp33_ = 0;
		const gchar* _tmp34_ = NULL;
		gchar* _tmp35_ = NULL;
		gint _tmp36_ = 0;
#line 301 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp33_ = level;
#line 301 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (!(_tmp33_ > 0)) {
#line 301 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			break;
#line 2894 "util-webkit.c"
		}
#line 302 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp34_ = outtext;
#line 302 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp35_ = g_strconcat (_tmp34_, "</blockquote>", NULL);
#line 302 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (outtext);
#line 302 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		outtext = _tmp35_;
#line 303 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp36_ = level;
#line 303 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		level = _tmp36_ - 1;
#line 2908 "util-webkit.c"
	}
#line 305 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = outtext;
#line 305 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_regex_unref0 (quote_leader);
#line 305 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 2916 "util-webkit.c"
}


/**
 * Convert a HTML DOM tree to RFC 3676 format=flowed text.
 *
 * This will modify/reset the DOM.
 */
static gchar* string_slice (const gchar* self, glong start, glong end) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	glong _tmp13_ = 0L;
	glong _tmp16_ = 0L;
	glong _tmp17_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	gchar* _tmp21_ = NULL;
#line 1336 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1337 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1337 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1337 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1338 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1338 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 2954 "util-webkit.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
#line 1339 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1339 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1339 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 2963 "util-webkit.c"
	}
#line 1341 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1341 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 2969 "util-webkit.c"
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
#line 1342 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1342 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1342 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 2978 "util-webkit.c"
	}
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 2984 "util-webkit.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 2993 "util-webkit.c"
	} else {
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 2997 "util-webkit.c"
	}
#line 1344 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp8_, NULL);
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp13_ = end;
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp13_ >= ((glong) 0)) {
#line 3005 "util-webkit.c"
		glong _tmp14_ = 0L;
		glong _tmp15_ = 0L;
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp14_ = end;
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp15_ = string_length;
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = _tmp14_ <= _tmp15_;
#line 3014 "util-webkit.c"
	} else {
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp12_ = FALSE;
#line 3018 "util-webkit.c"
	}
#line 1345 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1346 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp16_ = start;
#line 1346 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp17_ = end;
#line 1346 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp16_ <= _tmp17_, NULL);
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp20_ = start;
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp21_ = g_strndup (((gchar*) self) + _tmp18_, (gsize) (_tmp19_ - _tmp20_));
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp21_;
#line 1347 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 3040 "util-webkit.c"
}


static const gchar* string_to_string (const gchar* self) {
	const gchar* result = NULL;
#line 1420 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = self;
#line 1421 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 3052 "util-webkit.c"
}


static gchar* string_chomp (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 1199 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1200 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1200 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1201 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1201 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_strchomp (_tmp1_);
#line 1202 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _result_;
#line 1202 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 3075 "util-webkit.c"
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
#line 1094 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1095 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = index;
#line 1095 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = ((gchar*) self)[_tmp0_];
#line 1095 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 1095 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	return result;
#line 3093 "util-webkit.c"
}


static gint string_last_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1005 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1005 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1006 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 1006 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = needle;
#line 1006 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = g_strrstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
#line 1006 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 1008 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 1008 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 3120 "util-webkit.c"
		gchar* _tmp4_ = NULL;
#line 1009 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 1009 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 1009 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 3128 "util-webkit.c"
	} else {
#line 1011 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = -1;
#line 1011 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 3134 "util-webkit.c"
	}
}


static gint string_index_of (const gchar* self, const gchar* needle, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 995 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 995 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 996 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 996 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp1_ = needle;
#line 996 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp2_ = strstr (((gchar*) self) + _tmp0_, (gchar*) _tmp1_);
#line 996 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 998 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 998 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 3162 "util-webkit.c"
		gchar* _tmp4_ = NULL;
#line 999 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 999 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 999 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 3170 "util-webkit.c"
	} else {
#line 1001 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = -1;
#line 1001 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 3176 "util-webkit.c"
	}
}


gchar* html_to_flowed_text (WebKitDOMHTMLElement* el) {
	gchar* result = NULL;
	gchar* saved_doc = NULL;
	WebKitDOMHTMLElement* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	WebKitDOMNodeList* blockquotes = NULL;
	gint nbq = 0;
	WebKitDOMNodeList* _tmp9_ = NULL;
	gulong _tmp10_ = 0UL;
	gulong _tmp11_ = 0UL;
	gchar** bqtexts = NULL;
	gint _tmp12_ = 0;
	gchar** _tmp13_ = NULL;
	gint bqtexts_length1 = 0;
	gint _bqtexts_size_ = 0;
	gchar* doctext = NULL;
	WebKitDOMHTMLElement* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	gchar* _tmp57_ = NULL;
	gchar** _tmp58_ = NULL;
	gint _tmp58__length1 = 0;
	gchar* _tmp59_ = NULL;
	gchar* _tmp60_ = NULL;
	gchar* _tmp61_ = NULL;
	gchar* _tmp62_ = NULL;
	gchar** lines = NULL;
	const gchar* _tmp67_ = NULL;
	gchar** _tmp68_ = NULL;
	gchar** _tmp69_ = NULL;
	gint lines_length1 = 0;
	gint _lines_size_ = 0;
	GString* flowed = NULL;
	const gchar* _tmp70_ = NULL;
	gint _tmp71_ = 0;
	gint _tmp72_ = 0;
	GString* _tmp73_ = NULL;
	gchar** _tmp74_ = NULL;
	gint _tmp74__length1 = 0;
	GString* _tmp155_ = NULL;
	const gchar* _tmp156_ = NULL;
	gchar* _tmp157_ = NULL;
	GError * _inner_error_ = NULL;
#line 313 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (WEBKIT_DOM_IS_HTML_ELEMENT (el), NULL);
#line 314 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = el;
#line 314 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = webkit_dom_html_element_get_inner_html (_tmp0_);
#line 314 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	saved_doc = _tmp1_;
#line 3231 "util-webkit.c"
	{
		WebKitDOMNodeList* _tmp2_ = NULL;
		WebKitDOMHTMLElement* _tmp3_ = NULL;
		WebKitDOMNodeList* _tmp4_ = NULL;
		WebKitDOMNodeList* _tmp5_ = NULL;
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = el;
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = webkit_dom_element_query_selector_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, webkit_dom_element_get_type (), WebKitDOMElement), "blockquote", &_inner_error_);
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = _tmp4_;
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3245 "util-webkit.c"
			goto __catch192_g_error;
		}
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp5_ = _tmp2_;
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = NULL;
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (blockquotes);
#line 317 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		blockquotes = _tmp5_;
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (_tmp2_);
#line 3258 "util-webkit.c"
	}
	goto __finally192;
	__catch192_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 319 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp6_ = _error_;
#line 319 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = _tmp6_->message;
#line 319 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:319: Error selecting blockquotes: %s", _tmp7_);
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = g_strdup ("");
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp8_;
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (blockquotes);
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (saved_doc);
#line 320 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 3289 "util-webkit.c"
	}
	__finally192:
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (blockquotes);
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (saved_doc);
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 316 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 3304 "util-webkit.c"
	}
#line 323 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp9_ = blockquotes;
#line 323 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp10_ = webkit_dom_node_list_get_length (_tmp9_);
#line 323 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp11_ = _tmp10_;
#line 323 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	nbq = (gint) _tmp11_;
#line 324 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp12_ = nbq;
#line 324 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp13_ = g_new0 (gchar*, _tmp12_ + 1);
#line 324 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bqtexts = _tmp13_;
#line 324 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bqtexts_length1 = _tmp12_;
#line 324 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_bqtexts_size_ = bqtexts_length1;
#line 3324 "util-webkit.c"
	{
		gint i = 0;
		gint _tmp14_ = 0;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp14_ = nbq;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		i = _tmp14_ - 1;
#line 3332 "util-webkit.c"
		{
			gboolean _tmp15_ = FALSE;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp15_ = TRUE;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 3339 "util-webkit.c"
				gint _tmp17_ = 0;
				WebKitDOMHTMLElement* bq = NULL;
				WebKitDOMNodeList* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				WebKitDOMNode* _tmp20_ = NULL;
				WebKitDOMHTMLElement* _tmp21_ = NULL;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				WebKitDOMHTMLElement* _tmp24_ = NULL;
				gchar* _tmp25_ = NULL;
				gchar* _tmp26_ = NULL;
				gboolean _tmp27_ = FALSE;
				gchar** _tmp28_ = NULL;
				gint _tmp28__length1 = 0;
				gint _tmp29_ = 0;
				const gchar* _tmp30_ = NULL;
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp15_) {
#line 3361 "util-webkit.c"
					gint _tmp16_ = 0;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp16_ = i;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = _tmp16_ - 1;
#line 3367 "util-webkit.c"
				}
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp15_ = FALSE;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp17_ = i;
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(_tmp17_ >= 0)) {
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 3377 "util-webkit.c"
				}
#line 331 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp18_ = blockquotes;
#line 331 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp19_ = i;
#line 331 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp20_ = webkit_dom_node_list_item (_tmp18_, (gulong) _tmp19_);
#line 331 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, webkit_dom_html_element_get_type (), WebKitDOMHTMLElement));
#line 331 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				bq = _tmp21_;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp22_ = bqtexts;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp22__length1 = bqtexts_length1;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp23_ = i;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp24_ = bq;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp25_ = webkit_dom_html_element_get_inner_text (_tmp24_);
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (_tmp22_[_tmp23_]);
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp22_[_tmp23_] = _tmp25_;
#line 332 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp26_ = _tmp22_[_tmp23_];
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp28_ = bqtexts;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp28__length1 = bqtexts_length1;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp29_ = i;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp30_ = _tmp28_[_tmp29_];
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp31_ = strlen (_tmp30_);
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp32_ = _tmp31_;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (_tmp32_ > 0) {
#line 3419 "util-webkit.c"
					gchar** _tmp33_ = NULL;
					gint _tmp33__length1 = 0;
					gint _tmp34_ = 0;
					const gchar* _tmp35_ = NULL;
					gchar* _tmp36_ = NULL;
					gchar* _tmp37_ = NULL;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp33_ = bqtexts;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp33__length1 = bqtexts_length1;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp34_ = i;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp35_ = _tmp33_[_tmp34_];
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp36_ = string_substring (_tmp35_, (glong) -1, (glong) 1);
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp37_ = _tmp36_;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp27_ = g_strcmp0 (_tmp37_, "\n") == 0;
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp37_);
#line 3442 "util-webkit.c"
				} else {
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp27_ = FALSE;
#line 3446 "util-webkit.c"
				}
#line 333 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (_tmp27_) {
#line 3450 "util-webkit.c"
					gchar** _tmp38_ = NULL;
					gint _tmp38__length1 = 0;
					gint _tmp39_ = 0;
					gchar** _tmp40_ = NULL;
					gint _tmp40__length1 = 0;
					gint _tmp41_ = 0;
					const gchar* _tmp42_ = NULL;
					gchar* _tmp43_ = NULL;
					gchar* _tmp44_ = NULL;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp38_ = bqtexts;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp38__length1 = bqtexts_length1;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp39_ = i;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp40_ = bqtexts;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp40__length1 = bqtexts_length1;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp41_ = i;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp42_ = _tmp40_[_tmp41_];
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp43_ = string_slice (_tmp42_, (glong) 0, (glong) -1);
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp38_[_tmp39_]);
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp38_[_tmp39_] = _tmp43_;
#line 334 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp44_ = _tmp38_[_tmp39_];
#line 3482 "util-webkit.c"
				} else {
#line 336 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_debug ("util-webkit.vala:336: Did not find expected newline at end of quote.");
#line 3486 "util-webkit.c"
				}
				{
					WebKitDOMHTMLElement* _tmp45_ = NULL;
					const gchar* _tmp46_ = NULL;
					gint _tmp47_ = 0;
					gchar* _tmp48_ = NULL;
					gchar* _tmp49_ = NULL;
					const gchar* _tmp50_ = NULL;
					gchar* _tmp51_ = NULL;
					gchar* _tmp52_ = NULL;
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp45_ = bq;
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp46_ = string_to_string (QUOTE_START);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp47_ = i;
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp48_ = g_strdup_printf ("%i", _tmp47_);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp49_ = _tmp48_;
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp50_ = string_to_string (QUOTE_END);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp51_ = g_strconcat (_tmp46_, _tmp49_, _tmp50_, NULL);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp52_ = _tmp51_;
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					webkit_dom_html_element_set_inner_text (_tmp45_, _tmp52_, &_inner_error_);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp52_);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp49_);
#line 339 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3521 "util-webkit.c"
						goto __catch193_g_error;
					}
				}
				goto __finally193;
				__catch193_g_error:
				{
					GError* _error_ = NULL;
					GError* _tmp53_ = NULL;
					const gchar* _tmp54_ = NULL;
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_error_ = _inner_error_;
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_inner_error_ = NULL;
#line 341 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp53_ = _error_;
#line 341 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp54_ = _tmp53_->message;
#line 341 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_debug ("util-webkit.vala:341: Error manipulating DOM: %s", _tmp54_);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_error_free0 (_error_);
#line 3543 "util-webkit.c"
				}
				__finally193:
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (bq);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					bqtexts = (_vala_array_free (bqtexts, bqtexts_length1, (GDestroyNotify) g_free), NULL);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_object_unref0 (blockquotes);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (saved_doc);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					g_clear_error (&_inner_error_);
#line 338 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					return NULL;
#line 3562 "util-webkit.c"
				}
#line 330 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_object_unref0 (bq);
#line 3566 "util-webkit.c"
			}
		}
	}
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp55_ = el;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp56_ = webkit_dom_html_element_get_inner_text (_tmp55_);
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp57_ = _tmp56_;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp58_ = bqtexts;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp58__length1 = bqtexts_length1;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp59_ = resolve_nesting (_tmp57_, _tmp58_, _tmp58__length1);
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp60_ = _tmp59_;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp61_ = string_replace (_tmp60_, "\xc2\xa0", " ");
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp62_ = _tmp61_;
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp60_);
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp57_);
#line 346 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	doctext = _tmp62_;
#line 3594 "util-webkit.c"
	{
		WebKitDOMHTMLElement* _tmp63_ = NULL;
		const gchar* _tmp64_ = NULL;
#line 350 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp63_ = el;
#line 350 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp64_ = saved_doc;
#line 350 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		webkit_dom_html_element_set_inner_html (_tmp63_, _tmp64_, &_inner_error_);
#line 350 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 3606 "util-webkit.c"
			goto __catch194_g_error;
		}
	}
	goto __finally194;
	__catch194_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp65_ = NULL;
		const gchar* _tmp66_ = NULL;
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 352 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp65_ = _error_;
#line 352 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp66_ = _tmp65_->message;
#line 352 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:352: Error resetting DOM: %s", _tmp66_);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 3628 "util-webkit.c"
	}
	__finally194:
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (doctext);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		bqtexts = (_vala_array_free (bqtexts, bqtexts_length1, (GDestroyNotify) g_free), NULL);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (blockquotes);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (saved_doc);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_clear_error (&_inner_error_);
#line 349 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return NULL;
#line 3647 "util-webkit.c"
	}
#line 356 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp67_ = doctext;
#line 356 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp69_ = _tmp68_ = g_strsplit (_tmp67_, "\n", 0);
#line 356 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines = _tmp69_;
#line 356 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines_length1 = _vala_array_length (_tmp68_);
#line 356 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_lines_size_ = lines_length1;
#line 357 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp70_ = doctext;
#line 357 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp71_ = strlen (_tmp70_);
#line 357 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp72_ = _tmp71_;
#line 357 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp73_ = g_string_sized_new ((gsize) _tmp72_);
#line 357 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	flowed = _tmp73_;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp74_ = lines;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp74__length1 = lines_length1;
#line 3673 "util-webkit.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		line_collection = _tmp74_;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		line_collection_length1 = _tmp74__length1;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		for (line_it = 0; line_it < _tmp74__length1; line_it = line_it + 1) {
#line 3685 "util-webkit.c"
			gchar* _tmp75_ = NULL;
			gchar* line = NULL;
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp75_ = g_strdup (line_collection[line_it]);
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			line = _tmp75_;
#line 3692 "util-webkit.c"
			{
				const gchar* _tmp76_ = NULL;
				gint quote_level = 0;
				const gchar* _tmp83_ = NULL;
				gint _tmp84_ = 0;
				const gchar* _tmp85_ = NULL;
				gint _tmp86_ = 0;
				gint _tmp87_ = 0;
				gchar* _tmp88_ = NULL;
				gchar* _tmp89_ = NULL;
				gint _tmp90_ = 0;
				gchar* prefix = NULL;
				gchar* _tmp96_ = NULL;
				gint max_len = 0;
				const gchar* _tmp97_ = NULL;
				gint _tmp98_ = 0;
				gint _tmp99_ = 0;
#line 361 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp76_ = line;
#line 361 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (g_strcmp0 (_tmp76_, "-- ") != 0) {
#line 3714 "util-webkit.c"
					const gchar* _tmp77_ = NULL;
					gchar* _tmp78_ = NULL;
#line 362 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp77_ = line;
#line 362 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp78_ = string_chomp (_tmp77_);
#line 362 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (line);
#line 362 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					line = _tmp78_;
#line 3725 "util-webkit.c"
				}
#line 363 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				quote_level = 0;
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				while (TRUE) {
#line 3731 "util-webkit.c"
					const gchar* _tmp79_ = NULL;
					gint _tmp80_ = 0;
					gchar _tmp81_ = '\0';
					gint _tmp82_ = 0;
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp79_ = line;
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp80_ = quote_level;
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp81_ = string_get (_tmp79_, (glong) _tmp80_);
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (!(_tmp81_ == GEARY_RF_C822_UTILS_QUOTE_MARKER)) {
#line 364 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						break;
#line 3746 "util-webkit.c"
					}
#line 365 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp82_ = quote_level;
#line 365 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					quote_level = _tmp82_ + 1;
#line 3752 "util-webkit.c"
				}
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp83_ = line;
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp84_ = quote_level;
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp85_ = line;
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp86_ = strlen (_tmp85_);
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp87_ = _tmp86_;
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp88_ = string_slice (_tmp83_, (glong) _tmp84_, (glong) _tmp87_);
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (line);
#line 366 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				line = _tmp88_;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp90_ = quote_level;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (_tmp90_ > 0) {
#line 3774 "util-webkit.c"
					gint _tmp91_ = 0;
					gchar* _tmp92_ = NULL;
					gchar* _tmp93_ = NULL;
					gchar* _tmp94_ = NULL;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp91_ = quote_level;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp92_ = g_strnfill ((gsize) _tmp91_, '>');
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp93_ = _tmp92_;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp94_ = g_strconcat (_tmp93_, " ", NULL);
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp89_);
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp89_ = _tmp94_;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp93_);
#line 3793 "util-webkit.c"
				} else {
					gchar* _tmp95_ = NULL;
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp95_ = g_strdup ("");
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_g_free0 (_tmp89_);
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp89_ = _tmp95_;
#line 3802 "util-webkit.c"
				}
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp96_ = g_strdup (_tmp89_);
#line 367 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				prefix = _tmp96_;
#line 368 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp97_ = prefix;
#line 368 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp98_ = strlen (_tmp97_);
#line 368 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp99_ = _tmp98_;
#line 368 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				max_len = 72 - _tmp99_;
#line 3816 "util-webkit.c"
				{
					gboolean _tmp100_ = FALSE;
#line 370 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp100_ = TRUE;
#line 370 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					while (TRUE) {
#line 3823 "util-webkit.c"
						gint start_ind = 0;
						gboolean _tmp104_ = FALSE;
						gint _tmp105_ = 0;
						gint cut_ind = 0;
						const gchar* _tmp113_ = NULL;
						gint _tmp114_ = 0;
						gint _tmp115_ = 0;
						gint _tmp116_ = 0;
						gint _tmp117_ = 0;
						GString* _tmp139_ = NULL;
						const gchar* _tmp140_ = NULL;
						const gchar* _tmp141_ = NULL;
						gint _tmp142_ = 0;
						gchar* _tmp143_ = NULL;
						gchar* _tmp144_ = NULL;
						gchar* _tmp145_ = NULL;
						gchar* _tmp146_ = NULL;
						gchar* _tmp147_ = NULL;
						gchar* _tmp148_ = NULL;
						const gchar* _tmp149_ = NULL;
						gint _tmp150_ = 0;
						const gchar* _tmp151_ = NULL;
						gint _tmp152_ = 0;
						gint _tmp153_ = 0;
						gchar* _tmp154_ = NULL;
#line 370 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (!_tmp100_) {
#line 3851 "util-webkit.c"
							const gchar* _tmp101_ = NULL;
							gint _tmp102_ = 0;
							gint _tmp103_ = 0;
#line 392 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp101_ = line;
#line 392 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp102_ = strlen (_tmp101_);
#line 392 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp103_ = _tmp102_;
#line 392 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (!(_tmp103_ > 0)) {
#line 392 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								break;
#line 3865 "util-webkit.c"
							}
						}
#line 370 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp100_ = FALSE;
#line 371 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						start_ind = 0;
#line 372 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp105_ = quote_level;
#line 372 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (_tmp105_ == 0) {
#line 3876 "util-webkit.c"
							gboolean _tmp106_ = FALSE;
							const gchar* _tmp107_ = NULL;
							gboolean _tmp108_ = FALSE;
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp107_ = line;
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp108_ = g_str_has_prefix (_tmp107_, ">");
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (_tmp108_) {
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp106_ = TRUE;
#line 3888 "util-webkit.c"
							} else {
								const gchar* _tmp109_ = NULL;
								gboolean _tmp110_ = FALSE;
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp109_ = line;
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp110_ = g_str_has_prefix (_tmp109_, "From");
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp106_ = _tmp110_;
#line 3898 "util-webkit.c"
							}
#line 373 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp104_ = _tmp106_;
#line 3902 "util-webkit.c"
						} else {
#line 372 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp104_ = FALSE;
#line 3906 "util-webkit.c"
						}
#line 372 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (_tmp104_) {
#line 3910 "util-webkit.c"
							const gchar* _tmp111_ = NULL;
							gchar* _tmp112_ = NULL;
#line 374 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp111_ = line;
#line 374 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp112_ = g_strconcat (" ", _tmp111_, NULL);
#line 374 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_g_free0 (line);
#line 374 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							line = _tmp112_;
#line 375 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							start_ind = 1;
#line 3923 "util-webkit.c"
						}
#line 378 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp113_ = line;
#line 378 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp114_ = strlen (_tmp113_);
#line 378 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp115_ = _tmp114_;
#line 378 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						cut_ind = _tmp115_;
#line 379 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp116_ = cut_ind;
#line 379 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp117_ = max_len;
#line 379 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						if (_tmp116_ > _tmp117_) {
#line 3939 "util-webkit.c"
							gchar* beg = NULL;
							const gchar* _tmp118_ = NULL;
							gint _tmp119_ = 0;
							gchar* _tmp120_ = NULL;
							const gchar* _tmp121_ = NULL;
							gint _tmp122_ = 0;
							gint _tmp123_ = 0;
							gint _tmp124_ = 0;
#line 380 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp118_ = line;
#line 380 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp119_ = max_len;
#line 380 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp120_ = string_slice (_tmp118_, (glong) 0, (glong) _tmp119_);
#line 380 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							beg = _tmp120_;
#line 381 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp121_ = beg;
#line 381 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp122_ = start_ind;
#line 381 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp123_ = string_last_index_of (_tmp121_, " ", _tmp122_);
#line 381 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							cut_ind = _tmp123_ + 1;
#line 382 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_tmp124_ = cut_ind;
#line 382 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							if (_tmp124_ == 0) {
#line 3968 "util-webkit.c"
								const gchar* _tmp125_ = NULL;
								gint _tmp126_ = 0;
								gint _tmp127_ = 0;
								gint _tmp128_ = 0;
								gint _tmp132_ = 0;
								const gchar* _tmp133_ = NULL;
								gint _tmp134_ = 0;
								gint _tmp135_ = 0;
#line 383 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp125_ = line;
#line 383 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp126_ = start_ind;
#line 383 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp127_ = string_index_of (_tmp125_, " ", _tmp126_);
#line 383 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								cut_ind = _tmp127_ + 1;
#line 384 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp128_ = cut_ind;
#line 384 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (_tmp128_ == 0) {
#line 3989 "util-webkit.c"
									const gchar* _tmp129_ = NULL;
									gint _tmp130_ = 0;
									gint _tmp131_ = 0;
#line 385 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp129_ = line;
#line 385 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp130_ = strlen (_tmp129_);
#line 385 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp131_ = _tmp130_;
#line 385 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									cut_ind = _tmp131_;
#line 4001 "util-webkit.c"
								}
#line 386 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp132_ = cut_ind;
#line 386 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp133_ = prefix;
#line 386 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp134_ = strlen (_tmp133_);
#line 386 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								_tmp135_ = _tmp134_;
#line 386 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
								if (_tmp132_ > (998 - _tmp135_)) {
#line 4013 "util-webkit.c"
									const gchar* _tmp136_ = NULL;
									gint _tmp137_ = 0;
									gint _tmp138_ = 0;
#line 387 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp136_ = prefix;
#line 387 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp137_ = strlen (_tmp136_);
#line 387 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									_tmp138_ = _tmp137_;
#line 387 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
									cut_ind = 998 - _tmp138_;
#line 4025 "util-webkit.c"
								}
							}
#line 379 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
							_g_free0 (beg);
#line 4030 "util-webkit.c"
						}
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp139_ = flowed;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp140_ = prefix;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp141_ = line;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp142_ = cut_ind;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp143_ = string_slice (_tmp141_, (glong) 0, (glong) _tmp142_);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp144_ = _tmp143_;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp145_ = g_strconcat (_tmp140_, _tmp144_, NULL);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp146_ = _tmp145_;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp147_ = g_strconcat (_tmp146_, "\n", NULL);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp148_ = _tmp147_;
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						g_string_append (_tmp139_, _tmp148_);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (_tmp148_);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (_tmp146_);
#line 390 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (_tmp144_);
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp149_ = line;
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp150_ = cut_ind;
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp151_ = line;
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp152_ = strlen (_tmp151_);
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp153_ = _tmp152_;
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_tmp154_ = string_slice (_tmp149_, (glong) _tmp150_, (glong) _tmp153_);
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_free0 (line);
#line 391 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						line = _tmp154_;
#line 4076 "util-webkit.c"
					}
				}
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (prefix);
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (_tmp89_);
#line 358 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (line);
#line 4085 "util-webkit.c"
			}
		}
	}
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp155_ = flowed;
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp156_ = _tmp155_->str;
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp157_ = g_strdup (_tmp156_);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp157_;
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_string_free0 (flowed);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (doctext);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bqtexts = (_vala_array_free (bqtexts, bqtexts_length1, (GDestroyNotify) g_free), NULL);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (blockquotes);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (saved_doc);
#line 395 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 4111 "util-webkit.c"
}


static gchar* _vala_g_strjoinv (const gchar* separator, gchar** str_array, int str_array_length1) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
#line 1062 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp0_ = separator;
#line 1062 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp0_ == NULL) {
#line 1063 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		separator = "";
#line 4128 "util-webkit.c"
	}
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3_ = str_array;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	_tmp3__length1 = str_array_length1;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = TRUE;
#line 4138 "util-webkit.c"
	} else {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4_ = str_array;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp4__length1 = str_array_length1;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp4__length1 > 0;
#line 4148 "util-webkit.c"
	}
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp2_) {
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4154 "util-webkit.c"
	} else {
		gboolean _tmp5_ = FALSE;
		gchar** _tmp6_ = NULL;
		gint _tmp6__length1 = 0;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6_ = str_array;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp6__length1 = str_array_length1;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (_tmp6__length1 == -1) {
#line 4165 "util-webkit.c"
			gchar** _tmp7_ = NULL;
			gint _tmp7__length1 = 0;
			const gchar* _tmp8_ = NULL;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp7_ = str_array;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp7__length1 = str_array_length1;
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp8_ = _tmp7_[0];
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp5_ = _tmp8_ != NULL;
#line 4177 "util-webkit.c"
		} else {
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 4181 "util-webkit.c"
		}
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp1_ = _tmp5_;
#line 4185 "util-webkit.c"
	}
#line 1065 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
	if (_tmp1_) {
#line 4189 "util-webkit.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp31_ = 0;
		gint _tmp33_ = 0;
		gint _tmp34_ = 0;
		gsize _tmp35_ = 0UL;
		const gchar* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		gint _tmp38_ = 0;
		gint _tmp39_ = 0;
		const gchar* res = NULL;
		gsize _tmp40_ = 0UL;
		void* _tmp41_ = NULL;
		void* ptr = NULL;
		const gchar* _tmp42_ = NULL;
		gchar** _tmp43_ = NULL;
		gint _tmp43__length1 = 0;
		const gchar* _tmp44_ = NULL;
		void* _tmp45_ = NULL;
		const gchar* _tmp62_ = NULL;
#line 1067 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = (gsize) 1;
#line 4212 "util-webkit.c"
		{
			gboolean _tmp9_ = FALSE;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			i = 0;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp9_ = TRUE;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 4221 "util-webkit.c"
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gchar** _tmp13_ = NULL;
				gint _tmp13__length1 = 0;
				gint _tmp21_ = 0;
				gchar** _tmp22_ = NULL;
				gint _tmp22__length1 = 0;
				gint _tmp23_ = 0;
				const gchar* _tmp24_ = NULL;
				gsize _tmp30_ = 0UL;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (!_tmp9_) {
#line 4234 "util-webkit.c"
					gint _tmp10_ = 0;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp10_ = i;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					i = _tmp10_ + 1;
#line 4240 "util-webkit.c"
				}
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp9_ = FALSE;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp13_ = str_array;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp13__length1 = str_array_length1;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (_tmp13__length1 != -1) {
#line 4250 "util-webkit.c"
					gint _tmp14_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp14_ = i;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp15_ = str_array;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp15__length1 = str_array_length1;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp12_ = _tmp14_ < _tmp15__length1;
#line 4262 "util-webkit.c"
				} else {
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp12_ = FALSE;
#line 4266 "util-webkit.c"
				}
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (_tmp12_) {
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp11_ = TRUE;
#line 4272 "util-webkit.c"
				} else {
					gboolean _tmp16_ = FALSE;
					gchar** _tmp17_ = NULL;
					gint _tmp17__length1 = 0;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp17_ = str_array;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp17__length1 = str_array_length1;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					if (_tmp17__length1 == -1) {
#line 4283 "util-webkit.c"
						gchar** _tmp18_ = NULL;
						gint _tmp18__length1 = 0;
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp18_ = str_array;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp18__length1 = str_array_length1;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp19_ = i;
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp20_ = _tmp18_[_tmp19_];
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp16_ = _tmp20_ != NULL;
#line 4298 "util-webkit.c"
					} else {
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
						_tmp16_ = FALSE;
#line 4302 "util-webkit.c"
					}
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp11_ = _tmp16_;
#line 4306 "util-webkit.c"
				}
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (!_tmp11_) {
#line 1068 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					break;
#line 4312 "util-webkit.c"
				}
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp22_ = str_array;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp22__length1 = str_array_length1;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp23_ = i;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp24_ = _tmp22_[_tmp23_];
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (_tmp24_ != NULL) {
#line 4324 "util-webkit.c"
					gchar** _tmp25_ = NULL;
					gint _tmp25__length1 = 0;
					gint _tmp26_ = 0;
					const gchar* _tmp27_ = NULL;
					gint _tmp28_ = 0;
					gint _tmp29_ = 0;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp25_ = str_array;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp25__length1 = str_array_length1;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp26_ = i;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp27_ = _tmp25_[_tmp26_];
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp28_ = strlen ((const gchar*) _tmp27_);
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp29_ = _tmp28_;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp21_ = _tmp29_;
#line 4345 "util-webkit.c"
				} else {
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp21_ = 0;
#line 4349 "util-webkit.c"
				}
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp30_ = len;
#line 1069 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				len = _tmp30_ + _tmp21_;
#line 4355 "util-webkit.c"
			}
		}
#line 1071 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp31_ = i;
#line 1071 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		if (_tmp31_ == 0) {
#line 4362 "util-webkit.c"
			gchar* _tmp32_ = NULL;
#line 1072 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp32_ = g_strdup ("");
#line 1072 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			result = _tmp32_;
#line 1072 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			return result;
#line 4370 "util-webkit.c"
		}
#line 1074 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp33_ = i;
#line 1074 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		str_array_length1 = _tmp33_;
#line 1074 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp34_ = str_array_length1;
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp35_ = len;
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp36_ = separator;
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp37_ = strlen ((const gchar*) _tmp36_);
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp38_ = _tmp37_;
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp39_ = i;
#line 1075 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		len = _tmp35_ + (_tmp38_ * (_tmp39_ - 1));
#line 1077 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp40_ = len;
#line 1077 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp41_ = g_malloc (_tmp40_);
#line 1077 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		res = _tmp41_;
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp42_ = res;
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp43_ = str_array;
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp43__length1 = str_array_length1;
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp44_ = _tmp43_[0];
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp45_ = g_stpcpy ((void*) _tmp42_, (const gchar*) _tmp44_);
#line 1078 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		ptr = _tmp45_;
#line 4408 "util-webkit.c"
		{
			gboolean _tmp46_ = FALSE;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			i = 1;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			_tmp46_ = TRUE;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
			while (TRUE) {
#line 4417 "util-webkit.c"
				gint _tmp48_ = 0;
				gchar** _tmp49_ = NULL;
				gint _tmp49__length1 = 0;
				void* _tmp50_ = NULL;
				const gchar* _tmp51_ = NULL;
				void* _tmp52_ = NULL;
				const gchar* _tmp53_ = NULL;
				gchar** _tmp54_ = NULL;
				gint _tmp54__length1 = 0;
				gint _tmp55_ = 0;
				const gchar* _tmp56_ = NULL;
				void* _tmp60_ = NULL;
				void* _tmp61_ = NULL;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (!_tmp46_) {
#line 4433 "util-webkit.c"
					gint _tmp47_ = 0;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp47_ = i;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					i = _tmp47_ + 1;
#line 4439 "util-webkit.c"
				}
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp46_ = FALSE;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp48_ = i;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp49_ = str_array;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp49__length1 = str_array_length1;
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (!(_tmp48_ < _tmp49__length1)) {
#line 1079 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					break;
#line 4453 "util-webkit.c"
				}
#line 1080 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp50_ = ptr;
#line 1080 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp51_ = separator;
#line 1080 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp52_ = g_stpcpy (_tmp50_, (const gchar*) _tmp51_);
#line 1080 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				ptr = _tmp52_;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp54_ = str_array;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp54__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp55_ = i;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp56_ = _tmp54_[_tmp55_];
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				if (_tmp56_ != NULL) {
#line 4473 "util-webkit.c"
					gchar** _tmp57_ = NULL;
					gint _tmp57__length1 = 0;
					gint _tmp58_ = 0;
					const gchar* _tmp59_ = NULL;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp57_ = str_array;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp57__length1 = str_array_length1;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp58_ = i;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp59_ = _tmp57_[_tmp58_];
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp53_ = (const gchar*) _tmp59_;
#line 4488 "util-webkit.c"
				} else {
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
					_tmp53_ = "";
#line 4492 "util-webkit.c"
				}
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp60_ = ptr;
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				_tmp61_ = g_stpcpy (_tmp60_, _tmp53_);
#line 1081 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
				ptr = _tmp61_;
#line 4500 "util-webkit.c"
			}
		}
#line 1084 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp62_ = res;
#line 1084 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		res = NULL;
#line 1084 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = (gchar*) _tmp62_;
#line 1084 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 4511 "util-webkit.c"
	} else {
		gchar* _tmp63_ = NULL;
#line 1086 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		_tmp63_ = g_strdup ("");
#line 1086 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		result = _tmp63_;
#line 1086 "/usr/share/vala-0.34/vapi/glib-2.0.vapi"
		return result;
#line 4520 "util-webkit.c"
	}
}


gchar* quote_lines (const gchar* text) {
	gchar* result = NULL;
	gchar** lines = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint lines_length1 = 0;
	gint _lines_size_ = 0;
	gchar** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	gchar* _tmp17_ = NULL;
#line 398 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 399 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = text;
#line 399 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "\n", 0);
#line 399 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines = _tmp2_;
#line 399 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines_length1 = _vala_array_length (_tmp1_);
#line 399 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_lines_size_ = lines_length1;
#line 4548 "util-webkit.c"
	{
		gint i = 0;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		i = 0;
#line 4553 "util-webkit.c"
		{
			gboolean _tmp3_ = FALSE;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp3_ = TRUE;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 4560 "util-webkit.c"
				gint _tmp5_ = 0;
				gchar** _tmp6_ = NULL;
				gint _tmp6__length1 = 0;
				gchar** _tmp7_ = NULL;
				gint _tmp7__length1 = 0;
				gint _tmp8_ = 0;
				gchar* _tmp9_ = NULL;
				gchar* _tmp10_ = NULL;
				gchar** _tmp11_ = NULL;
				gint _tmp11__length1 = 0;
				gint _tmp12_ = 0;
				const gchar* _tmp13_ = NULL;
				gchar* _tmp14_ = NULL;
				gchar* _tmp15_ = NULL;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp3_) {
#line 4577 "util-webkit.c"
					gint _tmp4_ = 0;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp4_ = i;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					i = _tmp4_ + 1;
#line 4583 "util-webkit.c"
				}
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp3_ = FALSE;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp5_ = i;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp6_ = lines;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp6__length1 = lines_length1;
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(_tmp5_ < _tmp6__length1)) {
#line 400 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 4597 "util-webkit.c"
				}
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp7_ = lines;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp7__length1 = lines_length1;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp8_ = i;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp9_ = g_strdup_printf ("%c", GEARY_RF_C822_UTILS_QUOTE_MARKER);
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp10_ = _tmp9_;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp11_ = lines;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp11__length1 = lines_length1;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp12_ = i;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp13_ = _tmp11_[_tmp12_];
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (_tmp7_[_tmp8_]);
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp7_[_tmp8_] = _tmp14_;
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp15_ = _tmp7_[_tmp8_];
#line 401 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_g_free0 (_tmp10_);
#line 4627 "util-webkit.c"
			}
		}
	}
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp16_ = lines;
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp16__length1 = lines_length1;
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp17_ = _vala_g_strjoinv ("\n", _tmp16_, _tmp16__length1);
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp17_;
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 402 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 4643 "util-webkit.c"
}


static Block17Data* block17_data_ref (Block17Data* _data17_) {
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return _data17_;
#line 4652 "util-webkit.c"
}


static void block17_data_unref (void * _userdata_) {
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_slice_free (Block17Data, _data17_);
#line 4663 "util-webkit.c"
	}
}


static gboolean ___lambda47_ (Block17Data* _data17_, GMatchInfo* info, GString* res) {
	gboolean result = FALSE;
	gint key = 0;
	GMatchInfo* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gchar* prev_char = NULL;
	GMatchInfo* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* next_char = NULL;
	GMatchInfo* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gchar* insert_next = NULL;
	gchar* _tmp9_ = NULL;
	gboolean _tmp10_ = FALSE;
	const gchar* _tmp11_ = NULL;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_ = NULL;
	gboolean _tmp19_ = FALSE;
	gint _tmp20_ = 0;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (info != NULL, FALSE);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (res != NULL, FALSE);
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = info;
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = g_match_info_fetch (_tmp0_, 2);
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = _tmp1_;
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = atoi (_tmp2_);
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = _tmp3_;
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (_tmp2_);
#line 409 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	key = _tmp4_;
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = info;
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp6_ = g_match_info_fetch (_tmp5_, 1);
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	prev_char = _tmp6_;
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp7_ = info;
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp8_ = g_match_info_fetch (_tmp7_, 3);
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	next_char = _tmp8_;
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp9_ = g_strdup ("");
#line 410 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	insert_next = _tmp9_;
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp11_ = prev_char;
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (g_strcmp0 (_tmp11_, "") != 0) {
#line 4728 "util-webkit.c"
		const gchar* _tmp12_ = NULL;
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp12_ = prev_char;
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = g_strcmp0 (_tmp12_, "\n") != 0;
#line 4734 "util-webkit.c"
	} else {
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = FALSE;
#line 4738 "util-webkit.c"
	}
#line 412 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp10_) {
#line 4742 "util-webkit.c"
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
#line 413 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp13_ = prev_char;
#line 413 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp14_ = g_strconcat (_tmp13_, "\n", NULL);
#line 413 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (prev_char);
#line 413 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		prev_char = _tmp14_;
#line 4753 "util-webkit.c"
	}
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp16_ = next_char;
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (g_strcmp0 (_tmp16_, "") != 0) {
#line 4759 "util-webkit.c"
		const gchar* _tmp17_ = NULL;
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp17_ = next_char;
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp15_ = g_strcmp0 (_tmp17_, "\n") != 0;
#line 4765 "util-webkit.c"
	} else {
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp15_ = FALSE;
#line 4769 "util-webkit.c"
	}
#line 414 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp15_) {
#line 4773 "util-webkit.c"
		gchar* _tmp18_ = NULL;
#line 415 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp18_ = g_strdup ("\n");
#line 415 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (insert_next);
#line 415 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		insert_next = _tmp18_;
#line 4781 "util-webkit.c"
	}
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp20_ = key;
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp20_ >= 0) {
#line 4787 "util-webkit.c"
		gint _tmp21_ = 0;
		gchar** _tmp22_ = NULL;
		gint _tmp22__length1 = 0;
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp21_ = key;
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp22_ = _data17_->values;
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp22__length1 = _data17_->values_length1;
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp19_ = _tmp21_ < _tmp22__length1;
#line 4799 "util-webkit.c"
	} else {
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp19_ = FALSE;
#line 4803 "util-webkit.c"
	}
#line 416 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp19_) {
#line 4807 "util-webkit.c"
		GString* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		gchar** _tmp25_ = NULL;
		gint _tmp25__length1 = 0;
		gint _tmp26_ = 0;
		const gchar* _tmp27_ = NULL;
		gchar** _tmp28_ = NULL;
		gint _tmp28__length1 = 0;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		gchar* _tmp31_ = NULL;
		gchar* _tmp32_ = NULL;
		gchar* _tmp33_ = NULL;
		gchar* _tmp34_ = NULL;
		const gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		gchar* _tmp37_ = NULL;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp23_ = res;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp24_ = prev_char;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp25_ = _data17_->values;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp25__length1 = _data17_->values_length1;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp26_ = key;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp27_ = _tmp25_[_tmp26_];
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp28_ = _data17_->values;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp28__length1 = _data17_->values_length1;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp29_ = resolve_nesting (_tmp27_, _tmp28_, _tmp28__length1);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp30_ = _tmp29_;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp31_ = quote_lines (_tmp30_);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp32_ = _tmp31_;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp33_ = g_strconcat (_tmp24_, _tmp32_, NULL);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp34_ = _tmp33_;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp35_ = insert_next;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp36_ = g_strconcat (_tmp34_, _tmp35_, NULL);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp37_ = _tmp36_;
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_string_append (_tmp23_, _tmp37_);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp37_);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp34_);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp32_);
#line 417 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp30_);
#line 4869 "util-webkit.c"
	} else {
		GString* _tmp38_ = NULL;
#line 419 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:419: Regex error in denesting blockquotes: Invalid ke" \
"y");
#line 420 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp38_ = res;
#line 420 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_string_append (_tmp38_, "");
#line 4878 "util-webkit.c"
	}
#line 422 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = FALSE;
#line 422 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (insert_next);
#line 422 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (next_char);
#line 422 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (prev_char);
#line 422 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 4890 "util-webkit.c"
}


static gboolean ____lambda47__gregex_eval_callback (GMatchInfo* match_info, GString* _result_, gpointer self) {
	gboolean result;
	result = ___lambda47_ (self, match_info, _result_);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 4899 "util-webkit.c"
}


gchar* resolve_nesting (const gchar* text, gchar** values, int values_length1) {
	gchar* result = NULL;
	Block17Data* _data17_;
	gchar** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GError * _inner_error_ = NULL;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_data17_->_ref_count_ = 1;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = values;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0__length1 = values_length1;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_data17_->values = _tmp0_;
#line 405 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_data17_->values_length1 = _tmp0__length1;
#line 4923 "util-webkit.c"
	{
		GRegex* tokenregex = NULL;
		const gchar* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		GRegex* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = string_to_string (QUOTE_START);
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = string_to_string (QUOTE_END);
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = g_strconcat ("(.?)", _tmp1_, "([0-9]*)", _tmp2_, "(?=(.?))", NULL);
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp4_ = _tmp3_;
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error_);
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp6_ = _tmp5_;
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp4_);
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		tokenregex = _tmp6_;
#line 407 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 4955 "util-webkit.c"
			goto __catch195_g_error;
		}
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = tokenregex;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp9_ = text;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = g_regex_replace_eval (_tmp8_, _tmp9_, (gssize) -1, 0, 0, ____lambda47__gregex_eval_callback, _data17_, &_inner_error_);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = _tmp10_;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_regex_unref0 (tokenregex);
#line 4970 "util-webkit.c"
			goto __catch195_g_error;
		}
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp11_ = _tmp7_;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = NULL;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp11_;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (_tmp7_);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_regex_unref0 (tokenregex);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		block17_data_unref (_data17_);
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_data17_ = NULL;
#line 408 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 4989 "util-webkit.c"
	}
	goto __finally195;
	__catch195_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_error_ = _inner_error_;
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_inner_error_ = NULL;
#line 425 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp12_ = _error_;
#line 425 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp13_ = _tmp12_->message;
#line 425 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		g_debug ("util-webkit.vala:425: Regex error in denesting blockquotes: %s", _tmp13_);
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp14_ = g_strdup ("");
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp14_;
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_error_free0 (_error_);
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		block17_data_unref (_data17_);
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_data17_ = NULL;
#line 426 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 5020 "util-webkit.c"
	}
	__finally195:
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	block17_data_unref (_data17_);
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_data17_ = NULL;
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_clear_error (&_inner_error_);
#line 406 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return NULL;
#line 5033 "util-webkit.c"
}


gchar* assemble_data_uri (const gchar* mimetype, GearyMemoryBuffer* buffer) {
	gchar* result = NULL;
	gchar* base64 = NULL;
	GearyMemoryUnownedBytesBuffer* unowned_bytes = NULL;
	GearyMemoryBuffer* _tmp0_ = NULL;
	GearyMemoryUnownedBytesBuffer* _tmp1_ = NULL;
	GearyMemoryUnownedBytesBuffer* _tmp2_ = NULL;
	const gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
#line 432 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (mimetype != NULL, NULL);
#line 432 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (GEARY_MEMORY_IS_BUFFER (buffer), NULL);
#line 436 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = buffer;
#line 436 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GEARY_MEMORY_TYPE_UNOWNED_BYTES_BUFFER) ? ((GearyMemoryUnownedBytesBuffer*) _tmp0_) : NULL);
#line 436 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	unowned_bytes = _tmp1_;
#line 437 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = unowned_bytes;
#line 437 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp2_ != NULL) {
#line 5061 "util-webkit.c"
		GearyMemoryUnownedBytesBuffer* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		guint8* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 438 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp3_ = unowned_bytes;
#line 438 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp5_ = geary_memory_unowned_bytes_buffer_to_unowned_uint8_array (_tmp3_, &_tmp4_);
#line 438 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp6_ = g_base64_encode (_tmp5_, _tmp4_);
#line 438 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (base64);
#line 438 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		base64 = _tmp6_;
#line 5076 "util-webkit.c"
	} else {
		GearyMemoryBuffer* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		guint8* _tmp9_ = NULL;
		guint8* _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		gchar* _tmp11_ = NULL;
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = buffer;
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp9_ = geary_memory_buffer_get_uint8_array (_tmp7_, &_tmp8_);
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = _tmp9_;
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10__length1 = _tmp8_;
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp11_ = g_base64_encode (_tmp10_, _tmp8_);
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (base64);
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		base64 = _tmp11_;
#line 440 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = (g_free (_tmp10_), NULL);
#line 5100 "util-webkit.c"
	}
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp12_ = mimetype;
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp13_ = base64;
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp14_ = g_strdup_printf ("data:%s;base64,%s", _tmp12_, _tmp13_);
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = _tmp14_;
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (unowned_bytes);
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_free0 (base64);
#line 442 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 5116 "util-webkit.c"
}


gboolean dissasemble_data_uri (const gchar* uri, GearyMemoryBuffer** buffer) {
	GearyMemoryBuffer* _vala_buffer = NULL;
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gint start_index = 0;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gint base64_len = 0;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	guint8* bytes = NULL;
	const gchar* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	size_t _tmp16_;
	guchar* _tmp17_ = NULL;
	gint bytes_length1 = 0;
	gint _bytes_size_ = 0;
	gint bytes_length = 0;
	guint8* _tmp18_ = NULL;
	gint _tmp18__length1 = 0;
	guint8* _tmp19_ = NULL;
	gint _tmp19__length1 = 0;
	gint _tmp20_ = 0;
	GearyMemoryByteBuffer* _tmp21_ = NULL;
#line 449 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 450 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (_vala_buffer);
#line 450 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_vala_buffer = NULL;
#line 452 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = uri;
#line 452 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp1_ = g_str_has_prefix (_tmp0_, "data:");
#line 452 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (!_tmp1_) {
#line 453 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = FALSE;
#line 453 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (buffer) {
#line 453 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			*buffer = _vala_buffer;
#line 5164 "util-webkit.c"
		} else {
#line 453 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (_vala_buffer);
#line 5168 "util-webkit.c"
		}
#line 453 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 5172 "util-webkit.c"
	}
#line 456 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp2_ = uri;
#line 456 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = string_index_of (_tmp2_, ";", 0);
#line 456 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	start_index = _tmp3_;
#line 457 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = start_index;
#line 457 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp4_ <= 0) {
#line 458 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = FALSE;
#line 458 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		if (buffer) {
#line 458 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			*buffer = _vala_buffer;
#line 5190 "util-webkit.c"
		} else {
#line 458 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_g_object_unref0 (_vala_buffer);
#line 5194 "util-webkit.c"
		}
#line 458 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 5198 "util-webkit.c"
	}
#line 461 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = strlen ("base64,");
#line 461 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp6_ = _tmp5_;
#line 461 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	base64_len = _tmp6_;
#line 5206 "util-webkit.c"
	{
		gint ctr = 0;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		ctr = 0;
#line 5211 "util-webkit.c"
		{
			gboolean _tmp7_ = FALSE;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			_tmp7_ = TRUE;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
			while (TRUE) {
#line 5218 "util-webkit.c"
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				const gchar* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gchar _tmp13_ = '\0';
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!_tmp7_) {
#line 5226 "util-webkit.c"
					gint _tmp8_ = 0;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					_tmp8_ = ctr;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					ctr = _tmp8_ + 1;
#line 5232 "util-webkit.c"
				}
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp7_ = FALSE;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp9_ = ctr;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp10_ = base64_len;
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (!(_tmp9_ < _tmp10_)) {
#line 462 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					break;
#line 5244 "util-webkit.c"
				}
#line 463 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp11_ = uri;
#line 463 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp12_ = start_index;
#line 463 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				start_index = _tmp12_ + 1;
#line 463 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				_tmp13_ = string_get (_tmp11_, (glong) _tmp12_);
#line 463 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
				if (_tmp13_ == GEARY_STRING_EOS) {
#line 464 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					result = FALSE;
#line 464 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					if (buffer) {
#line 464 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						*buffer = _vala_buffer;
#line 5262 "util-webkit.c"
					} else {
#line 464 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
						_g_object_unref0 (_vala_buffer);
#line 5266 "util-webkit.c"
					}
#line 464 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
					return result;
#line 5270 "util-webkit.c"
				}
			}
		}
	}
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp14_ = uri;
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp15_ = start_index;
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp17_ = g_base64_decode ((const gchar*) (((gchar*) _tmp14_) + _tmp15_), &_tmp16_);
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes = _tmp17_;
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes_length1 = _tmp16_;
#line 468 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_bytes_size_ = bytes_length1;
#line 472 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp18_ = bytes;
#line 472 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp18__length1 = bytes_length1;
#line 472 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes_length = _tmp18__length1;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp19_ = bytes;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp19__length1 = bytes_length1;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes = NULL;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes_length1 = 0;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp20_ = bytes_length;
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp21_ = geary_memory_byte_buffer_new_take (_tmp19_, _tmp19__length1, (gsize) _tmp20_);
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_g_object_unref0 (_vala_buffer);
#line 473 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_vala_buffer = G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEARY_MEMORY_TYPE_BUFFER, GearyMemoryBuffer);
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = TRUE;
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	bytes = (g_free (bytes), NULL);
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (buffer) {
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		*buffer = _vala_buffer;
#line 5317 "util-webkit.c"
	} else {
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_object_unref0 (_vala_buffer);
#line 5321 "util-webkit.c"
	}
#line 475 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 5325 "util-webkit.c"
}


gchar* smart_escape (const gchar* text, gboolean preserve_whitespace_in_html) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* res = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp9_ = FALSE;
#line 481 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp0_ = text;
#line 481 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp0_ == NULL) {
#line 5342 "util-webkit.c"
		const gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
#line 482 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp1_ = text;
#line 482 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp2_ = g_strdup (_tmp1_);
#line 482 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		result = _tmp2_;
#line 482 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		return result;
#line 5353 "util-webkit.c"
	}
#line 484 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp3_ = text;
#line 484 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 484 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	res = _tmp4_;
#line 485 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp5_ = res;
#line 485 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp6_ = g_regex_match_simple ("<([A-Z]*)(?: [^>]*)?>.*</(\\1)>|<[A-Z]*(?: [^>]*)?/>", _tmp5_, G_REGEX_CASELESS, 0);
#line 485 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (!_tmp6_) {
#line 5367 "util-webkit.c"
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 487 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp7_ = res;
#line 487 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp8_ = geary_html_escape_markup (_tmp7_);
#line 487 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (res);
#line 487 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		res = _tmp8_;
#line 488 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		preserve_whitespace_in_html = TRUE;
#line 5380 "util-webkit.c"
	}
#line 490 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	_tmp9_ = preserve_whitespace_in_html;
#line 490 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	if (_tmp9_) {
#line 5386 "util-webkit.c"
		const gchar* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
		gchar* _tmp12_ = NULL;
#line 491 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp10_ = res;
#line 491 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp11_ = string_to_string (_tmp10_);
#line 491 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_tmp12_ = g_strconcat ("<div style='white-space: pre;'>", _tmp11_, "</div>", NULL);
#line 491 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		_g_free0 (res);
#line 491 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
		res = _tmp12_;
#line 5400 "util-webkit.c"
	}
#line 492 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	result = res;
#line 492 "/builddir/build/BUILD/geary-0.11.4/src/client/util/util-webkit.vala"
	return result;
#line 5406 "util-webkit.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 5413 "util-webkit.c"
		int i;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
				destroy_func (((gpointer*) array)[i]);
#line 5421 "util-webkit.c"
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	g_free (array);
#line 5433 "util-webkit.c"
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	if (array) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
		while (((gpointer*) array)[length]) {
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
			length++;
#line 5446 "util-webkit.c"
		}
	}
#line 8 "/builddir/build/BUILD/geary-0.11.4/src/client/notification/libnotify.vala"
	return length;
#line 5451 "util-webkit.c"
}



